<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012  <>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

 // Помечаем, что работает мод "gSexy (старое название) | Board (новое название)"
define("T3_EXT_MODE", "gSexy");
define("T3_EXT_MODE", "Boards");
 
// Если мы что-то грузим по ajax
/* ВСЕ ЭТО МЫ НЕ ВЫВОДИМ ЕСЛИ РАБОТАЕТ AJAX */

IF (!strstr($GLOBALS['_SERVER']['SCRIPT_NAME'], "ajax.php")):

	unset($MCONF);
	require ('conf.php');
	$GLOBALS['LANG']->includeLLFile('EXT:boards/mod1/locallang.xml');
	$GLOBALS['BE_USER']->modAccess($MCONF, 1);	// This checks permissions and exits if the users has no permission for entry.
		// DEFAULT initialization of a module [END]
		
		
											#print "<pre>";
											#print_r($GLOBALS['BE_USER']);
											#exit();
		
ENDIF;

/**
 * Module 'boards' for the 'boards' extension.
 *
 * @author	 <>
 * @package	TYPO3
 * @subpackage	tx_testtree
 */ 
//require_once(PATH_typo3conf.'ext/boards/pbild/class.tcabild.php'); //включаем класс для создания динам.tca
require_once(PATH_t3lib . 'class.t3lib_scbase.php');
class tx_testtree_module1 extends t3lib_SCbase {
	
	protected $pageinfo;
	protected $numopenelement; //для хранения списка уникальных ключей через ";" открытых веток в дереве для текущего пользователя BE
	protected $last_news_records_add; //в данную переменную заносим недавно добавленные элементы, что бы их выделить другим цветом на досске...
	protected $countI = 0; //счетчик элементов для массива
	protected $is_lock_board; //в данную переменную пишем статус доступа к доске...
	protected $sys_language_codes; // в данную переменную собираем иконки языков по коду языка.
	protected $sys_language_records; // список текущих созданных языков на сайтеп 
	protected $pidBoard; // текущий pid-боарда, на котором раскрываются доски (по нему записывается new.defVar.pid)
	
		// Функция получает список кодов языка из TCA - таблицы Sys_language
	function getCodeSysLanguage(){
		
		// Список кодов языков
		foreach ($GLOBALS['TCA']['sys_language']['columns']['flag']['config']['items'] as $key => $value){
			$path = $value[2];
			$path = preg_replace("/EXT:/", "/typo3/sysext/", $path);
			$this->sys_language_codes[$value[0]] = $path;
		}
		// Список текущих языков на сайте
		$res = $GLOBALS['TYPO3_DB']->sql_query('SELECT * FROM sys_language');
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$this->sys_language_records[ $row['uid'] ] = $row['flag'];
		}
	
	}
	
	/**
	 * Initializes the module.
	 *
	 * @return void
	 */
	public function init() {
		#parent::init();

		/*
		if (t3lib_div::_GP('clear_all_cache'))	{
			$this->include_once[] = PATH_t3lib . 'class.t3lib_tcemain.php';
		}
		*/
	}

	/**
	 * Main function of the module. Write the content to $this->content
	 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	 *
	 * @return void
	 */
	public function main() {
	
			// Access check!
			// The page will show only if there is a valid page and if this page may be viewed by the user
		//$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id, $this->perms_clause);
		//$access = is_array($this->pageinfo) ? 1 : 0;
	
		//if (($this->id && $access) || ($GLOBALS['BE_USER']->user['admin'] && !$this->id)) {
		// if (!$this->id){
		//if (1 == 1){
		
				// Draw the header.
			$this->doc = t3lib_div::makeInstance('bigDoc');
			$this->doc->backPath = $GLOBALS['BACK_PATH'];
			//$this->doc->form = '<form action="" method="post" enctype="multipart/form-data">';

				// CSS-file
			$this->doc->getPageRenderer()->addCssFile(t3lib_extMgm::extRelPath('boards') . 'mod1/systemdir/depo.css');
			$this->doc->inDocStylesArray[] = '
							
			/* веточки */
			.joinbottom  { display: inline-block; vertical-align: middle; margin-right: 0px; width: 22px; height: 16px; background: url("gfx/ol/joinbottom.gif") 4px 0px no-repeat; border: red 0px solid; }
			.join { display: inline-block; vertical-align: middle; margin-right: 0px; width: 22px; height: 16px; background: url("gfx/ol/join.gif") 4px 0px no-repeat; border: red 0px solid; }
			.line { display: inline-block; vertical-align: middle; margin-right: 0px; width: 22px; height: 16px; background: url("gfx/ol/line.gif") 4px 0px no-repeat; border: red 0px solid; }
			.blank { display: inline-block; vertical-align: middle; margin-right: 0px; width: 22px; height: 16px; background: url("gfx/ol/blank.gif") 4px 0px no-repeat; border: red 0px solid; }

			';
			
				// JavaScript
			$this->doc->loadJavascriptLib('contrib/prototype/prototype.js');
			$this->doc->loadJavascriptLib('js/common.js');
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
				<script src="'.t3lib_extMgm::extRelPath('boards') .'mod1/systemdir/jquery-1.8.3.min.js"></script>
				<script src="'.t3lib_extMgm::extRelPath('boards') .'mod1/systemdir/document-ready_without_ajax.js"></script>
			';
			$this->doc->postCode = '
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) {
						top.fsMod.recentIds["web"] = '.$this->id.'; // что бы выбранная страница в дереве не сбрасывалась
					}
					if (top.TYPO3.Backend.NavigationContainer.PageTree) {
						top.TYPO3.Backend.NavigationContainer.PageTree.select('.$this->id.'); // что бы выбранная страница в дереве не сбрасывалась
						top.TYPO3.Backend.NavigationContainer.PageTree.refreshTree();
					}
				</script>
			';
			
				// В зависимости от версии TYPO3 шаблон
			if (version_compare(TYPO3_branch, '6.0', '>=')) {
				$template = file_get_contents(t3lib_extMgm::extRelPath('boards') . 'mod1/mod_template.TYPO3.6.x+.html');
			} else {
				$template = file_get_contents(t3lib_extMgm::extRelPath('boards') . 'mod1/mod_template.TYPO3.4.5.x+.html');
			}
			$arrMarkers['###BUTTONLIST_RIGHT###'] = '
				Количество отмеченных элементов: <span id="countSelectedElements" style="color: white; border-radius: 3px; font-size: 9px; padding: 0 3px 1px 3px; background-color: red;">-</span> |
				время загрузки ветки: <span id="iblInfoTimeLoad">-</span> | 
				количество открытых элементов: <span id="iblInfoCountLoadElements">'.(($GLOBALS['BE_USER']->uc['tx_board_bonding'][ 'openElementsCount' ] <= 0) ? "-" : $GLOBALS['BE_USER']->uc['tx_board_bonding'][ 'openElementsCount' ]).'</span> 
			';
			$arrMarkers['###INFO###'] = '
				<input id="flag_tooltip" type="checkbox" value="1" style="vertical-align: middle;"> <label for="flag_tooltip">включить всплывающие подсказки</label>
				<!--<input type="checkbox" checked value="1" style="vertical-align: middle;" disabled> отключение ajax при количество открытых элементов 250+-->
			';
			$arrMarkers['###CONTENT###'] = '
						<h2>'.$this->getPageTitle().'</h2>
						
						<table border="0" cellpadding="0" cellspacing="0" class="typo3-dblist">
						<tr class="c-table-row-spacer"><td></td></tr>
						<tr class="t3-row-header">
							<td nowrap="nowrap">'.t3lib_iconWorks::getSpriteIcon('apps-pagetree-root').'&nbsp;<!--Быстрое управление содержимым:-->'. $GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'].'</td>
							<td align="right" style="padding-right: 5px;">
								<div id="iblbloctreeevent_clear" style="height: 18px; float: right; cursor: pointer !important;">
									<div id="iblbloctreeevent_clear_wrap">
										<span href="?M=web_txtestM1&id='.intval($GLOBALS["_GET"]["id"]).'&treeevent[clear]=1" class="iblFunction_check_treeevent_clear">
										закрыть все ветки <img src="../typo3conf/ext/boards/mod1/icon/broom.png" style="vertical-align: middle;"></span>
									</div>
								</div>
								<span id="iblFunction_SeeDopInformation" style="float: right; cursor: pointer" class="dop-information-button">
									Дополнительная информация
									<img src="../typo3/sysext/t3skin/icons/module_web_info.png" style="vertical-align: middle;"> | &nbsp;
								</span>
							</td>
						</tr>
						<!--
						<tr>
							<td colspan="3" bgcolor="#eeeeee" height="20" style="position: relative;">
								<input type="text" style="margin: 0; padding: 0; position: absolute; top: 3px; left: 50%; right: 3px; " value="Поиск записей на досках...">
							</td>
						</tr>
						-->
						<tr>
							<td colspan="2" class="modcontent">
								<div style="position: relative;">
								<div id="iblblock_tree">
								<div id="iblblock_tree_wrap">
									' . $this->moduleContent() . '
								</div>
								</div>
								</div>
							
								<!---->
								<div id="panel_moderation_wrap_top" style="display: none; background: url('.t3lib_extMgm::extRelPath('boards') .'mod1/img/bg-fon-admpanel.jpg);">
								<div id="panel_moderation_wrap" style="border: red 0px solid;">
									<!--Контейнер для панели-->
									<div id="panel_moderation">
									
											
											
									</div>
								</div>
								</div>
							
								<!--Контейнер для блокировки содержимого в режиме открытой панели-->
								<div class="disabledmodcontent" style="display: none;">
								<DIV STYLE="WIDTH: 100%; HEIGHT: 100%; BORDER: RED 0PX SOLID;
								background: url('.t3lib_extMgm::extRelPath('boards') .'mod1/icon/earth.png) center center no-repeat;">
								
								<!--<IMG SRC="" ALIGN="CENTER" VALIGN="MIDDLE">-->
								
								</DIV>
								</div>
							</td>
						</tr>
						<tr>
							<td colspan="2" style="border-top: #d7d7d7 1px solid; background-color: #ece2bc;">
								Горячие клавишы: 1) <b>Shift+движение мышью</b> - выделить необходимые элементы; 2) <b>Ctrl+движение мышью</b> - снять отметки с необходимых элементов. 3) <b>Esc</b>-снять отметки со всех.<br />
								При наведении на подсказку, что бы скопировать из нее текст - к примеру sql-запрос или id-элемента - можно зажать "~" и подсказка не будет пропадать.<br />
								<br />
								Настоятельно не рекомендуется открывать более 50 документов на редактирование одновременно.
								После завершения работы с досками - необходимо произвести "Очиститку открытых элементов дерева".
								<br />
								<br />
								<b style="color: gray">*</b> подсказки бело-серого цвета обозначают значение о связи записанной в текущем элементе<br />
								<b style="color: blue">*</b> подсказки синего цвета обозначают значение о связи записанной в родительском элементе<br />
								<b style="color: green">*</b> подсказки зеленого цвета обозначают значение о связи внутреннего построения дерева (на базе одной таблицы)<br />
								<b style="color: #8143ce">*</b> подсказки фиолетового цвета обозначают смешанные связи
								<br />
								<br />
								<span class="all_accesss_type r">R</span> - означает возможность чтения (только просмотра) записей из данной таблицы <br />
								<span class="all_accesss_type w">W</span> - означает возможность изменения записей в данной таблице (если установлено-значит чтение (<span class="all_accesss_type r">R</span>) также разрешается автоматически)<br />
								<span class="all_accesss_type w">S</span> - означает наличие доступа к хранилищу где расположена запись и есть возможноть ее править '. t3lib_iconWorks::getSpriteIcon('status-dialog-ok') .'-1 / ' . t3lib_iconWorks::getSpriteIcon('status-dialog-ok') .'-16. <br />
								
								<br >
								'.t3lib_iconWorks::getSpriteIcon('status-warning-in-use').' - если рядом с записью появилась данная иконка - значит запись уже кто-то редактирует.<br />
								Также обратите внимание - если хранилище удалено в корзину - то записи могут быть не доступны на сайте!
								<br />
								<br >
								<img src="'.t3lib_extMgm::extRelPath('boards') .'res/translate.png"
										style="vertical-align: middle; margin-top: -1px;"> - если напротив записи появляется данная иконка - значит для данных записей включена возможность переводов на другие языки<br />
								<img src="'.t3lib_extMgm::extRelPath('boards') .'res/lang-default.png"
										style="vertical-align: middle; margin-top: -1px;"> - язык записи по умолчанию<br />
								<img src="'.t3lib_extMgm::extRelPath('boards') .'res/lang-multi.png"
									style="vertical-align: middle; margin-top: -1px;"> - мультиязычный язык
							</td>
						</tr>
						</table>
						<table style="width: 450px;" border="0" cellpadding="0" cellspacing="0" class="typo3-dblist">
						<tr class="c-table-row-spacer"><td></td></tr>
						<tr class="t3-row-header">
							<td width="50%" nowrap="nowrap"><img src="../typo3conf/ext/boards/res/panel.png">&nbsp;Настройки поведения досок</td>
						</tr>
						<tr>
							<td>
								<input id="flag_deleted_element" 
								'.(($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_deleted_element'] == 1) ? "checked" : null ).'
								type="checkbox" value="1" style="vertical-align: middle;" > <label for="flag_deleted_element" style=" cursor: pointer;">
								<span  style="vertical-align: middle;">Выводить записи удаленные в корзину </span> 
								'.t3lib_iconWorks::getSpriteIcon('status-overlay-deleted').'</label><br />
								
								<input id="flag_show_translate" 
								'.(($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_show_translate'] == 1) ? "checked" : null ).'
								type="checkbox" value="1" style="vertical-align: middle;" > <label for="flag_show_translate" style=" cursor: pointer;">
								<span  style="vertical-align: middle;">Показывать переводы записей </span></label><br />
								
								<input disabled type="checkbox" style="vertical-align: middle; cursor: default;" checked> 
								<span  style="vertical-align: middle;">Выводить выключенные записи</span> 
								'.t3lib_iconWorks::getSpriteIcon('status-overlay-hidden').'<br />
								
								<input disabled type="checkbox" style="vertical-align: middle; cursor: default;" checked> 
								<span  style="vertical-align: middle;">Выключить Ajax</span><br />
								
								<!--
								К записям отображать <input type="radio" disabled checked>комментарии / <input type="radio" disabled> подробные данные (beta)<br />
								<input id="flag_lost" type="checkbox" value="1" style="vertical-align: middle; background-color: red;" disabled> <label for="flag_lost">отобразить утерянные/битые элементы (beta)</label><br />
								<input id="flag_nullresult" type="checkbox" value="1" style="vertical-align: middle; background-color: red;" disabled> <label for="flag_nullresult">скрыть нулевые результаты (beta)</label><br />
								<input id="flag_info" type="checkbox" value="1" style="vertical-align: middle;" disabled> <label for="flag_info">показать подробные данные (на передлку)</label><br />
								<input id="flag_dialog" type="checkbox" value="1" style="vertical-align: middle;"> <label for="flag_dialog">выключить диалоги</label>
								-->
							</td> 
						</tr>
						</table>
			';

			$this->content .= $this->doc->startPage($GLOBALS['LANG']->getLL('title'));	
			$this->content .= str_replace(array('###BUTTONLIST_RIGHT###','###INFO###','###CONTENT###'), array($arrMarkers['###BUTTONLIST_RIGHT###'],$arrMarkers['###INFO###'],$arrMarkers['###CONTENT###']), $template);
			$this->content .= $this->doc->spacer(10);
			
			//$this->content .= $this->doc->spacer(10);
		/* } else {
				// If no access or if ID == zero

			$this->doc = t3lib_div::makeInstance('bigDoc');
			$this->doc->backPath = $GLOBALS['BACK_PATH'];

			$this->content .= $this->doc->startPage($GLOBALS['LANG']->getLL('title'));
			$this->content .= $this->doc->spacer(5);
			$this->content .= $this->doc->spacer(10);
		} */
	
	}

	/**
	 * Prints out the module HTML.
	 *
	 * @return void
	 */
	public function printContent() {
		
		//$this->content .= "<hr>* - данные должны быть уникальными в построенном дереве склеиваний<hr>";
		$this->content .= $this->doc->endPage();
		echo $this->content;
		
	}
	
	//Функция получает название страницы
	function getPageTitle() {
		if ($GLOBALS['_GET']['id'] == 0) {
			return $GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'];
		} else {
			$row = t3lib_befunc::getRecord('pages', intval($GLOBALS["_GET"]["id"]), 'title');
			return $row['title'];
		}
	}
	
	//Функция определяе доступ к доске
	function BEaccessBoard( $accessBoard, $userId ){
	
		//Разбираем что в правах досок

		//Если доступно всем...
		if ($accessBoard == -1)
		return 0;
		
		$arex = explode ("," , $accessBoard);
		for ($i = 0; $i < count ($arex); $i ++){
		
			if ($arex[$i] == $userId)
			return 0;
			
		}
		
		//Если не нашли id-пользователя - выходим
		return 1; //блокируем
	}

	/**
	 * Generates the module content.
	 *
	 * @return void
	 */
	function moduleContent() {
	
	//Заполняем данными об открытых ветках
	$this->numopenelement = $this->BEsessionEventtree();
	$this->last_news_records_add = $GLOBALS['BE_USER']->uc['tx_board_bonding_new_records_add']; //недавно добавленные элементы
	
	//Если нам передан ID-боарда - для ajax-конкретно обновлять это board
	
	
		/*
			Создание доски красной доски - если ее нет (просто insert).
			Для корневого уровня сайта.
			$GLOBALS['_GET']['id']
		*/
		if (intval($GLOBALS['_GET']['id']) == 0){
			$res = $GLOBALS['TYPO3_DB']->sql_query("SELECT uid FROM tx_board_bonding WHERE is_special_board_platform = 1 LIMIT 1");
			if ($GLOBALS['TYPO3_DB']->sql_num_rows( $res ) == 0){
				$GLOBALS['TYPO3_DB']->sql_query("
					
					INSERT INTO tx_board_bonding (uid,title,is_special_board_platform) 
					VALUES ('','Специальная доска',1);
				
				");
			}
		} 
	
	
	
	// Если у нас хранилище ID > 0 (не корневой уровень, то от туда извлекаем только его доски, если на "0" уровне - извлекаем все
	if ($GLOBALS['_GET']['id'] > 0){
		$addWhereNotRootNode = " AND pid = ".intval($GLOBALS['_GET']['id']) . " ";
	}
	
	//Излекаем все доски слеивания
	$res = $GLOBALS['TYPO3_DB']->sql_query("SELECT uid,pid,ts_settings,service_note,is_special_board_platform,be_user_access,hidden FROM tx_board_bonding WHERE deleted = 0 ". $addWhereNotRootNode ." ORDER BY sorting ASC");
	$num = $GLOBALS['TYPO3_DB']->sql_num_rows( $res );
	
	//$sql = 'SELECT * FROM tx_board_bonding WHERE hidden = 0 and deleted = 0 ORDER BY title';
	
	//Замеряем время работя скрипта
	//$start = microtime(true);
	if ($num == 0){
		
		return "
		<div id='iblblock_tree_".$row['uid']."'><div id='iblblock_tree_wrap_".$row['uid']."'>
		<ul><li><div class='allpanelelement' style='border-left: black 3px solid; padding: 5px;'>
		" . t3lib_iconWorks::getSpriteIcon('apps-pagetree-page-no-icon-found') . " В выбранном хранилище досок не найдено!
		</li></ul></div></div></div>";
		
	
	}
	
	while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {

		//Создаем корень досок//Немного модифицируем TS-конфигурацию, добавляя доску в качестве первого уровня
		$GLOBALS['id'] = 1; $GLOBALS['table_parent'] = null; //для синих веток сохраняе таблицу родителя....
		if ($row['is_special_board_platform'] == 1) $row ['ts_settings'] = file_get_contents(PATH_typo3conf . "ext/boards/static/ts_special_board.txt"); //если это специальная доска
		
		$this->getCodeSysLanguage(); // подгуражем коды языков
		$this->is_lock_board = $this->BEaccessBoard($row['be_user_access'], $GLOBALS['BE_USER']->user['uid']); //проверяем доступ к доске...
		$row ['ts_settings'] = "
			
            1 = tx_board_bonding
			1.settings.border-color = black
			1.settings.commentary = service_note
            1.settings.where = uid = ".$row['uid']." AND deleted = 0
			
			
			# Перенесено сюда...
			1.panelmoderation = 1
			1.panelmoderation.eventdisabled = new|delete|hidden
			
			# Временно пока сделал так заблокировку...
			1.system.lock = ".($row['hidden'] == 1 ? 1 : 0)."
			
			#это временное событие - начало развития темы прав доступа - для второго поколения
			#1.system.lock = ".$this->is_lock_board."
            1 {
				".$row ['ts_settings']."
            }  
			
		";
		
		//Производим парсинг данных
		$tsParser = t3lib_div::makeInstance('t3lib_TSparser');
		$tsParser->parse( $row ['ts_settings'] );
		$result = $tsParser->setup;
			
		$this->pidBoard = $row['pid'];
		$treeArray = $this -> bildTree( $row['uid'], $result ); 		//Собираем дерево
		
		//Замеряем время работя скрипта
		$time = microtime(true) - $start;
				
				
		#print "<br /><br />" . ('Скрипт 1 выполнялся '.round($time,3).' сек.');
		#print "<pre>";
		#print_r($treeArray);
				
		
		
				
		#print "<pre>";
		#print_r($treeArray);
		#exit();
		
		
		$content .= "<div id='iblblock_tree_".$row['uid']."'><div id='iblblock_tree_wrap_".$row['uid']."'>";
		$content .= $this -> htmlTree ($row['uid'], $treeArray, 0);	//Выводим собранное дерево
		$content .= "</div></div>";
		
		//Замеряем время работя скрипта
		//$time2 = microtime(true) - $start;
		
		
		
		#print "<br />" . ('Скрипт 2 выполнялся '.round($time,3).' сек.');
		#exit();
	}
		
		// Записываем кол-во открытых элементов
		$GLOBALS['BE_USER']->uc['tx_board_bonding'][ 'openElementsCount_' . $row['uid'] ] = count($treeArray);
		$GLOBALS['BE_USER']->overrideUC(); 
		$GLOBALS['BE_USER']->writeUC(); 
		
		//$content .= "<DIV STYLE='POSITION: FIXED; TOP: 0PX; BACKGROUND-COLOR: WHITE; LEFT: 200PX;'>
		//Время загрузки: " .('Скрипт 1 выполнялся '.round($time,3).' сек.'). " <br />
		//Время загрузки: " .('Скрипт 2 выполнялся '.round($time2,3).' сек.'). " <br />
		//| Кол-во показанных элементов: " .count($treeArray). "</DIV>";
		return $content;
	}
	
	
	
	/**
	 * Generates the module content.
	 *
	 * @return void
	 */
	function moduleContentAjax() {
	
	//Заполняем данными об открытых ветках
	$this->numopenelement = $this->BEsessionEventtree();
	$this->last_news_records_add = $GLOBALS['BE_USER']->uc['tx_board_bonding_new_records_add']; //недавно добавленные элементы
	
	// Если у нас хранилище ID > 0 (не корневой уровень, то от туда извлекаем только его доски, если на "0" уровне - извлекаем все
	if ($GLOBALS['_GET']['id'] > 0){
		$addWhereNotRootNode = " AND pid = ".intval($GLOBALS['_GET']['id']) . " ";
	}
	
	//Если нам передан ID-боарда - для ajax-конкретно обновлять это board
	$res = $GLOBALS['TYPO3_DB']->sql_query("SELECT uid,pid,ts_settings,service_note,is_special_board_platform,be_user_access,hidden FROM tx_board_bonding WHERE deleted = 0 " . $addWhereNotRootNode . " AND uid = ".$GLOBALS['_GET']['boardUidOnly']." LIMIT 1;"); 
	//$sql = 'SELECT * FROM tx_board_bonding WHERE hidden = 0 and deleted = 0 ORDER BY title'; //Излекаем все доски слеивания
	
	//Замеряем время работя скрипта
	$start = microtime(true);
	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);

		//Создаем корень досок//Немного модифицируем TS-конфигурацию, добавляя доску в качестве первого уровня
		$GLOBALS['id'] = 1; $GLOBALS['table_parent'] = null; //для синих веток сохраняе таблицу родителя....
		if ($row['is_special_board_platform'] == 1) $row ['ts_settings'] = file_get_contents(PATH_typo3conf . "ext/boards/static/ts_special_board.txt"); //если это специальная доска

		$this->getCodeSysLanguage(); // подгуражем коды языков
		$this->is_lock_board = $this->BEaccessBoard($row['be_user_access'], $GLOBALS['BE_USER']->user['uid']); //проверяем доступ к доске...
		$row ['ts_settings'] = "
			
            1 = tx_board_bonding
			1.settings.border-color = black
			1.settings.commentary = service_note
            1.settings.where = uid = ".$row['uid']." AND deleted = 0
			
			# Перенесено сюда...
			1.panelmoderation = 1
			1.panelmoderation.eventdisabled = new|delete|hidden
			
			# Временно пока сделал так заблокировку...
			1.system.lock = ".($row['hidden'] == 1 ? 1 : 0)."
			
			#это временное событие - начало развития темы прав доступа - для второго поколения
			#1.system.lock = ".$this->is_lock_board."
            1 {
				".$row ['ts_settings']."
            }  
			
		";
		
		//Производим парсинг данных
		$tsParser = t3lib_div::makeInstance('t3lib_TSparser');
		$tsParser->parse( $row ['ts_settings'] );
		$result = $tsParser->setup;
			
		
		$this->pidBoard = $row['pid']; // записываем текущий pid-доски (нужно для new.defVar.pid=...)
		$treeArray = $this -> bildTree( $row['uid'], $result ); 		//Собираем дерево
		$content = $this -> htmlTree ($row['uid'], $treeArray, 0);	//Выводим собранное дерево
		
		//Замеряем время работя скрипта
		$time = microtime(true) - $start;
		
		
		
		#print "<br />" . ('Скрипт 2 выполнялся '.round($time,3).' сек.');
		#exit();
		
		//$content .= "<DIV STYLE='POSITION: FIXED; TOP: 0PX; BACKGROUND-COLOR: WHITE; LEFT: 200PX;'>
		//Время загрузки: " .('Скрипт 1 выполнялся '.round($time,3).' сек.'). " <br />
		//Время загрузки: " .('Скрипт 2 выполнялся '.round($time2,3).' сек.'). " <br />
		//| Кол-во показанных элементов: " .count($treeArray). "</DIV>";
		
		// Записываем кол-во открытых элементов
		$GLOBALS['BE_USER']->uc['tx_board_bonding'][ 'openElementsCount_' . $row['uid'] ] = count($treeArray);
		$GLOBALS['BE_USER']->overrideUC(); 
		$GLOBALS['BE_USER']->writeUC(); 
		
		return "<input id='iblblock_tree_".$row['uid']."_InfoTimeLoad_value' type='hidden' value='".round($time,3)."'>" .
		"<input id='iblblock_tree_".$row['uid']."_InfoCountLoadElements_value' type='hidden' value='".count($treeArray)."'>"	. 
		$content;
	}
		
	
	/* 
		Сборка дерева
		
		event НЕ АКТУАЛЬНО = СОБЫТИЕ (пропувстить выполнение foreach,например помещение в папочку и т.д. , подсчет кол-ва дочерних элементов и т.д.)
		
		uid-доски (нужно для добавления к уникальному ключу...
		numopenelement - элементы открытые через точку с запятой (ПЕРЕВЕЛИ В ПЕРЕМЕННЫЕ КЛАССА VAR)
		ar - массив с ts-конфигурацией 
		start - внутрянняя переменная, которой сообщается позциция в дереве чтения
		damp_parent - информация для дочек от родительский элемент который вызывает функцию для следующего вложенного уровня
		systemevent - служебные события - создание папки, лимит и т.д.
		uidboard
		padding - отступы веточек
		level
		
		//table_parent - таблица - уровнем выше, (для синих веточек)
	*/ 
	
	function bildTree ($uidboard, $ts_ar, $start = false, $damp_parent = false, $systemevent = null, $parentIDdesc = 0, $level = 0, $table_parent = null ){
	//global $COUNT_ELEMENT; /* в этом содержиться вся иерархия дерева компиляции дерева (для правильной выборки из сессии и ajax)
	/* if (
		1
		1.1
		1.1.1
		1.1.1.1
		1.2.1.1
		...
	*/
		//Стартовые элемент
		$ts_ar_original = $ts_ar;
		if ($start == true)
		$ts_ar = $ts_ar[$start];
		
		#$handleConstant = fopen(PATH_typo3conf . "ext/info.txt", 'a+');
		#$arrayContent =  print_r($ts_ar,true);			
		#fwrite($handleConstant, $arrayContent); //Запись массива (в виде строки)
		#fclose($handleConstant);
		
		//Сохраняем значение роидтеля
		$oldparentIDdesc = $parentIDdesc;
		
		//Сортируем массив по ключам, 
		ksort($ts_ar); //вроде бы работает

		foreach ($ts_ar as $key => $val)
		#for ($j = 0; $j < count ($ts_ar); $j++)
		{ 
			#if ($ts_ar[$j] == null)
			#continue;
			
			#$key = $j;
			#$val = $ts_ar[$key];
			
			#print $key;
			#print "<pre>";
			#print_r($ts_ar);
			#print $ts_ar[$j."."];
			#exit();
			#$key = $ts_ar;
			//первый val - это название таблицы
			//второй val - это массив поднастроек (влож.таблицы)
				
				if (is_int ($key))
				{
						$resultwhere = null; //ОБЯЗАТЕЛЬНО ЗАЧИЩАЕМ ИСПОЛЬЗУЮЩИЕСЯ ПЕРЕМЕННЫЕ - инчае БАГочищаем переменную с уловиями...
						$where = $columnselect = $order = $titleName = $relationmethod = $limit = $color = $addprefix_ifinsert_into = $relationfieldvalue_green_save = null; //очистка
						$sql = $sql_count = $sql_error = $sql_broken = null; //очистка
						
						// (TS-config) Явное перечисление полей на извлечение колонок) - очень актуально если дерево большое
						$columnselect = ($ts_ar[$key . "."]['settings.']['onlycolumn'] == true) ? $ts_ar[$key . "."]['settings.']['onlycolumn'] : " * ";
					
						// (TS-config) Сортировка (если задана сортировка)...
						$order = ($ts_ar[$key . "."]['settings.']['sort'] == true) ? " ORDER BY " . $ts_ar[$key . "."]['settings.']['sort'] : null;
					
						/* (TS-config) т.к. может быть, что имя названия содержимого храниться в разном поле...*/
						// NEW! 01.07.2013 - если значение не задано - берем из $GLOBALS['TCA'][$table]['ctrl']['label']
						// $titleName = ($ts_ar[$key . "."]['settings.']['fieldname']) ? $ts_ar[$key . "."]['settings.']['fieldname'] : 'title';
						if ( !isset($ts_ar[$key . "."]['settings.']['fieldname']) ) // если не задано - берем значение поля с именем по умолчанию 
						$titleName = $GLOBALS['TCA'][$val]['ctrl']['label'];
						else 
						$titleName = $ts_ar[$key . "."]['settings.']['fieldname'];
						
						// (TS-config) Дополнительные условия
						if ($ts_ar[$key . "."]['settings.']['where'] != null) {
						
							$resultwhere[0] = $ts_ar[$key . "."]['settings.']['where'];
							
							// New - если есть на что заменить от родителя
							if ($ts_ar[$key . "."]['settings.']['where.']['replace.']){
								
								// # Заменяем на значение от родителя
								// settings.where = pid IN (~property_storage)
								// settings.where.replace.property_storage = 1
		
								foreach ($ts_ar[$key . "."]['settings.']['where.']['replace.'] as $keyReplace => $valueReplace)
								$resultwhere[0] = str_replace ("~" . $keyReplace , $damp_parent[ $keyReplace ], $resultwhere[0]);
								
								
							}
						
						}
						//if (count ($resultwhere) > 0) $where = " WHERE " . implode (" AND " , $resultwhere);
						
						/* (TS-config) панель модерирования (panelmoderation.new.defvar.)...*/
						//$ar_newdefvar = $ts_ar[$key . "."]['settings.']; panelmoderation.new.defvar.
						
						// (TS-config) - ПРОСТО МЕТКА-Данные в дереве должны быть уникальными (т.е. на них должен ссылкаться тольк один родитель)
						//$unique1 = ($ts_ar[$key . "."]['settings.']['unique'] == 1) ? "<font style='color: green'><b>*</b></font>" : null;
						
						// (TS-config) РАЗБОР СВЯЗЕЙ (один из 2-ух вариантов + 3 внутрнннее построение дерева)
						$relationmethod = $ts_ar[$key . "."]['relation.']['field.'];
						$parent_element = ( $damp_parent['uid'] > 0) ? $damp_parent['uid'] : 0;
						
						//вариант 1 (СИНИЕ ВЕТОЧКИ) - parent (связь содержится в родителе)
						if (isset($relationmethod['parent'])){
						
							//+ Если у нас существуе поле, в котором содержаться мульти, данные к примеру, tx_infoblock_structure_4, tx_infoblock_structure_3, tx_other_table_2
							//Преобразуем в цифры
							$relationfieldvalue = $relationmethod['parent'];  //получаем поле связи - значение field
							$relationfieldvalue_blue_save = $relationfieldvalue; //сохраняем поле синей связи...
							$resultwhere[1] = $this->wheretype($val, $relationfieldvalue, $damp_parent);
							$color = 'blue';
							
							
							// (TS-config) ЕСЛИ ЗАДАЕТСЯ ОРИГИНАЛЬНАЯ СОРТИРОВКА КАК В ПОЛЕ
							// ВНИМАНИЕ - возможно это  переписысвает значение 
							if ($relationmethod['parent.']['sortoriginal'] == true){
							//FIND_IN_SET( uid,  '". $damp_p['palettes_group'] ."' )
								
									preg_match("/\((.+)\)/i", $resultwhere[1], $matches); //вырезаем из строки данные
									$order = " ORDER BY FIND_IN_SET( uid,  '".trim($matches[1])."' ) ";
								#exit();
								
							}
							#if ($resultwhere[1] == null) //если путо пропускаем данную связь
							#continue;
						}
						//вариант 2(СЕРЫЕ ВЕТОЧКИ) - parent (связь содержится в дочке)
						if (isset($relationmethod['children'])){
						
							$relationfieldvalue = $relationmethod['children'];  //получаем поле связи - значение field
							$resultwhere[1] = $this->wheretype($val, $relationfieldvalue, $damp_parent);
							$color = 'gray';
							
							//++++++++++++++++++++++++++++++++++//
							//++++++++++++++++++++++++++++++++++//
							$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.'][$relationfieldvalue] = $parent_element; //(меняем значение для панелиадминистрирования)//
							//++++++++++++++++++++++++++++++++++//
							//++++++++++++++++++++++++++++++++++//
							
							if ($resultwhere[1] == null) //если путо пропускаем данную связь
							continue;
							
						} else {
						
							//ОБЫЧНАЯ ВЫБОРКА... 
							//$damp_parent = null; //уничтожаем данные о родителе...
							#$color = null;
						
						}
						
						//Если есть связи в пределах текущей таблицы (дерево из одной таблицы)
						// (TS-config)  вариант 3 (ЗЕЛЕНЫЕ ВЕТОЧКИ) - связь построения дерева из одной таблице
						if (isset($relationmethod['this'])){
						
								$relationfieldvalue = $relationmethod['this'];  //получаем поле связи - значение field
								$relationfieldvalue_green_save = $relationfieldvalue; //сохраняем поле зеленой связи...
								
								$resultwhere[2] = $relationfieldvalue . " = " . $relationmethod['this.']['startpoint']; //" pid = 0 "; //pid = 0
								$color .= 'green'; //делаем как добавление...
								
								//++++++++++++++++++++++++++++++++++//
								//++++++++++++++++++++++++++++++++++//
								$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.'][$relationfieldvalue] = $relationmethod['this.']['startpoint']; //(меняем значение для панелиадминистрирования)//
								//++++++++++++++++++++++++++++++++++//
								//++++++++++++++++++++++++++++++++++//
								
								//Также сохраняем стартовую точку, что бы ее пускать в улович...
								if ( $GLOBALS['tmp']['startpointoriginal'][$key] == null ){
								
									$GLOBALS['tmp']['startpointoriginal'][$key] = $relationmethod['this.']['startpoint'];
									$level = 0; //сбрасываем значение расчета уровня
								
								}
						}
						
						#print $key . "<br />";
						
						////////////////////////////////////////////////////////////////////////////////
						// Флаг (Настройки поведения досок) - Показать записи помещенные в корзину
						////////////////////////////////////////////////////////////////////////////////
						if ($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_deleted_element'] != 1){
							// Если не установлено "сркть записи помещенные в коризну"
							if (isset($GLOBALS['TCA'][$val]['ctrl']['delete'])){
								$resultwhere[5] = $GLOBALS['TCA'][$val]['ctrl']['delete'] . " = 0";
							}
						}
						
						
						
						/***************
						
						
						
							Главное новввоведение, после того, как модуль стал
							двигаться по дереву страниц.
							Во все условия в обязательном порядке добавляется
							AND pid = ".intval($GLOBALS['_GET']['id'])."
							Пока только прои условии, что это не корень сайта.
							На корневом уровне можно делать что угодно!!!! :).
						
							Также это отображается на вставке новой записи!
							Ей всегда присваивается 
							1.panelmoderation.new.defvar.pid = 29
						
						
						
						***************/
						// if (intval($GLOBALS['_GET']['id']) > 0){
						if ($this->pidBoard > 0 // записываем текущий pid-доски (нужно для new.defVar.pid=...)
						&& $ts_ar[$key . "."]['settings.']['where_ignore_pid'] == FALSE) { // икногировать pid-хранилища (данная настройка не рекомендована к использованию)
							// $resultwhere[3] = " pid = ".intval($GLOBALS['_GET']['id'])." ";
							// $ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'] = intval($GLOBALS['_GET']['id']);
							$resultwhere[3] = " pid = ".$this->pidBoard." ";
							$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'] = $this->pidBoard;
						}
						
						
						/***************
						
						
						
							Автоматизация локализации-языков
							Что бы было удобно делать переводы
							При условии, что в настройках отмечено, 
							что показывать переводы в поведении досок
						
						
						***************/
						# if ($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_show_translate'] == 1) {
						
							// Обычно это - "pages_language_overlay"
							if (!empty($GLOBALS['TCA'][$val]['ctrl']['transForeignTable']) && $val == "pages"){ // сделал только для данной таблицы :)
								if (isset($GLOBALS['TCA'][$val]['ctrl']['transForeignTable'])){
										// Добавляем в конфик
									/*
										40.1 = pages_language_overlay
										40.1.settings.folder = Переводы
										40.1.settings.sort = sys_language_uid
										40.1.relation.field.children = pid:type-1
										40.1.panelmoderation = 1
										40.1.panelmoderation.eventdisabled = new|delete
									*/
									if ($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_show_translate'] == 1) {
										if ($ts_ar[$key . "."]['settings.']['folder.']['isFolderTranslate'] == 0){
											// Создаем папочку с отображением переводов
											$ts_ar[$key . "."]['-1'] = $val . "_language_overlay";
											# $ts_ar[$key . "."]['-1.']['settings.']['folder'] = "Переводы";
											$ts_ar[$key . "."]['-1.']['settings.']['folder.']['isFolderTranslate'] = 1; // так помечаем, что это папка
											$ts_ar[$key . "."]['-1.']['settings.']['where_ignore_pid'] = 1;
											$ts_ar[$key . "."]['-1.']['settings.']['sort'] = "sys_language_uid";
											$ts_ar[$key . "."]['-1.']['relation.']['field.']['children'] = "pid:type-1";
											$ts_ar[$key . "."]['-1.']['panelmoderation'] = "1";
											$ts_ar[$key . "."]['-1.']['panelmoderation.']['eventdisabled'] = "new|delete";
										}
									}
								}
								// Assemble language condition only if a language field is defined
							} elseif (!empty($GLOBALS['TCA'][$val]['ctrl']['languageField'])) {
								if(isset($GLOBALS['TCA'][$val]['ctrl']['transOrigPointerField'])){	
										// Добавляем в конфик
									/*
										51.1 = {$val}
										51.1.settings.folder = Переводы
										51.1.settings.sort = sys_language_uid
										51.1.relation.field.children = l18n_parent:type-1
										51.1.panelmoderation = 1
										51.1.panelmoderation.eventdisabled = new|delete
									*/
									if ($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_show_translate'] == 1) {	
										if ($ts_ar[$key . "."]['settings.']['folder.']['isFolderTranslate'] == 0){
											// Добавляем условие только родителю
											$localizationAddWhere = "
												( sys_language_uid IN (-1,0) AND l18n_parent=0 )
												OR
												( sys_language_uid > 0 AND l18n_parent=0 )
											";
											$resultwhere[4] = $localizationAddWhere;
											
											// Создаем папочку с отображением переводов
											$ts_ar[$key . "."]['-1'] = $val;
											# $ts_ar[$key . "."]['-1.']['settings.']['folder'] = "Переводы";
											$ts_ar[$key . "."]['-1.']['settings.']['folder.']['isFolderTranslate'] = 1; // так помечаем, что это папка
											$ts_ar[$key . "."]['-1.']['settings.']['where_ignore_pid'] = 1;
											$ts_ar[$key . "."]['-1.']['settings.']['sort'] = "sys_language_uid";
											$ts_ar[$key . "."]['-1.']['relation.']['field.']['children'] = "l18n_parent:type-1";
											$ts_ar[$key . "."]['-1.']['panelmoderation'] = "1";
											$ts_ar[$key . "."]['-1.']['panelmoderation.']['eventdisabled'] = "new|delete";
										}
									} else {
										// Добавляем условие только родителю
										$localizationAddWhere = "
											( sys_language_uid IN (-1,0) AND l18n_parent=0 )
											OR
											( sys_language_uid > 0 AND l18n_parent=0 )
										";
										$resultwhere[4] = $localizationAddWhere;
									}
									
								}
							} else {
								 // пропускаем если ни тот, 
								 // ни другой вариант локализации
							}
						
						# }
						
						
						// Собираем итоговые условия
						if (count ($resultwhere) > 0) 
						$where = " WHERE " . implode (" AND " , $resultwhere);
						
						// Запрос на проверку активности, включенности, выключенности (для веток ниже)...
						// $clause = " 1=1 " . t3lib_BEfunc::deleteClause($val) ."<br />". t3lib_BEfunc::BEenableFields($val);
						//ts-config - enableFieldsValidation // по умолчанию определено всегда - так решил
						//$where_clause = (trim($where_clause) != null && $where == null ) ? " WHERE " . $where_clause : null;
						$where_clause = $this->addWhere_with_deleteClause_and_BEenableFields($val , $where);
						
						//Формируем запросы к БД
						$sql_broken = "SELECT {$columnselect} FROM {$val} WHERE pid != " . $GLOBALS['tmp']['startpointoriginal'][$key] . " AND (pid NOT IN (SELECT uid FROM {$val} " . (($resultwhere[0] != null) ? " WHERE " . $resultwhere[0] : null) . ") OR pid = uid)"; //поиск бытых/утерянных элементов
						$sql_validation = "SELECT {$columnselect} FROM {$val} {$where_clause} {$order}"; //проверяем состояние каждого элемента (решил не делать 1 запросом) на предмет вкл.вык.,удал., что бы отметить далее по списку ветки, которые от него следуют как не активные;
						$sql_count = "SELECT count(uid) as result_count FROM {$val} {$where}"; // {$order} //кол-во записей при данном раскладе
						$sql = "SELECT {$columnselect} FROM {$val} {$where} {$order}"; //обычный запрос
						
						// Сохраняем оригиналы запросов
						$sql_original = $sql; //сохраняем оригинал запросов
						$sql_validation_original = $sql_validation; //сохраняем оригинал запросов
						
						//////////////////////////////////////////////////////////////////////
						//ВОЗМОЖНОЕ СОБЫТИЕ С RETURN в момент сборки дерева 
						//№1: подсчет кол-ва элементов в дочерней папочке
						//////////////////////////////////////////////////////////////////////
								if ($systemevent == "todo_countelements"):
						
									$res = $GLOBALS['TYPO3_DB']->sql_query ($sql_count); // or die ( $GLOBALS['TYPO3_DB']->sql_error() );
									$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
							
									$row_count += $row['result_count'];
									continue;
						
								endif;
						//////////////////////////////////////////////////////////////////////
								
						
						//ВОЗМОЖНОЕ СОБЫТИЕ №2: обертка содержимого в папку...
						// (TS-config) Если нас просят создать папочку для данного изобретения
						$createfolder = $ts_ar[$key . "."]['settings.']['folder'];
						$create_folder_flag = 0; //флаг на то, создали мы папку или нет
						if ($createfolder != null):
						
							
							//Количество элементов в папке
							$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $GLOBALS['TYPO3_DB']->sql_query ($sql_count) ); //Если у нас нет внутреннего постороения дерева - считаем элементы
							
							//Создаем папочку и помечаем ее как служебную...
							//Передаем тот-же массив что и сейчас работает у нас
							$UNICALE_key_inAllTree = "folder_{$val}_{$uidboard}_{$key}_".$parent_element; //здесь вставлено как можно больше значений, что бы избежать путанницы
							//$INPUT_HIDDEN_PANELMODERATION_VALUE = "board:{$uidboard}|table:{$val}|uid:-|pid:".$ts_ar[$key . "."]['panelmoderation.']['newdef_varpid']."|panel:".$ts_ar[$key . "."]['panelmoderation']."|panel-fieldname:{$titleName}|panel-newdef_varpid:".$ts_ar[$key . "."]['panelmoderation.']['newdef_varpid']."|panel-eventdisabled:@edit@hidden@delete"; //(TS-config) данные для панели администирования
							$CHILDREN_ARRAY[ ] = array ('title' => "<!--<u>-->{$createfolder}<!--</u>-->",
														
														"pid" => ($parentIDdesc == 0) ? 0 : $parentIDdesc,
														"id" => $GLOBALS['id'], //id-pid в рамках доски
										
 														'systemElementTree' => 1,
														'typeElem' => 'folder',
														"relation_color" => $color,
														'toooltip_info' => array(
												
																//справочная информация для всплывающей подсказки
																'sql_query' => $sql, //mysql-запрос к базе данных на выборку данного элемента
																'UNICALE_key_generation' => $UNICALE_key_inAllTree, //уникальный ключ
																'PANELMODERATION_value' => ($ts_ar[$key . "."]['panelmoderation'] == 1) ? $INPUT_HIDDEN_PANELMODERATION_VALUE : "board:{$uidboard}|table:{$val}|panelModerationIsUndefined", //для панели
																'countelements' => intval($row['result_count'])
														),
							);
						
							//Если папка закрыта - прерываеся----
							if ($this->searchUNICALE_key ($UNICALE_key_inAllTree) == 0) { $GLOBALS['id'] ++; continue; }
							$parentIDdesc = $GLOBALS['id']; //переименовываем родителя
							$GLOBALS['id'] ++;  //генерируем следующий уник. элемент...
							$create_folder_flag = 1;

						endif;
						
						
						// (TS-config) - ПРОСТО МЕТКА-Данные в дереве должны быть уникальными (т.е. на них должен ссылкаться тольк один родитель)
						$limit = $ts_ar[$key . "."]['settings.']['limit'];
						
						///////////////////////////////////
						//РАЗЛИМИЧИВАНИЕ ДАННЫХ
						///////////////////////////////////
						
						//Получаем количество записей всего: //Количество элементов в папке
						$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $GLOBALS['TYPO3_DB']->sql_query ($sql_count) ); //Если у нас нет внутреннего постороения дерева - считаем элементы
						$k = 1; $flag_select = 1; //вводим счетсик и флаг на разрешение извлечения данных
						while (1){
								
								//Создение папки - при уловии что лимит > 0 и кол-во записей больше лимита...
								if ($limit > 0 and $row['result_count'] >= $limit){
									
									
										//Создаем папочку и помечаем ее как служебную...
										//Передаем тот-же массив что и сейчас работает у нас
										$UNICALE_key_inAllTree = "limit_record_{$val}_{$uidboard}_{$key}_{$k}_".$parent_element; //здесь вставлено как можно больше значений, что бы избежать путанницы
										$CHILDREN_ARRAY[ ] = array ('title' => "<!--<u>-->Записи с " . $k . " по ".($k+$limit-1)."<!--</u>-->",
																	
																	"pid" => ($parentIDdesc == 0) ? 0 : $parentIDdesc,
																	"id" => $GLOBALS['id'], //id-pid в рамках доски
													
																	'systemElementTree' => 1,
																	'typeElem' => 'limit_record',
																	"relation_color" => $color,
																	'toooltip_info' => array(
															
																			//справочная информация для всплывающей подсказки
																			'sql_query' => $sql, //mysql-запрос к базе данных на выборку данного элемента
																			'UNICALE_key_generation' => $UNICALE_key_inAllTree, //уникальный ключ
																			//'countelements' => $row['result_count']
																	),
										);
									
										//Если папка закрыта - прерываеся----
										//Если папка закрыта - прерываеся----
										if ($this->searchUNICALE_key ($UNICALE_key_inAllTree) == 0) { 
											
												$GLOBALS['id'] ++; 
												$sql = $sql_original . " LIMIT 0 "; 
												$sql_validation = $sql_validation_original . " LIMIT 0 "; 
												$flag_select = 0;
											
										} else {
											$sql = $sql_original . " LIMIT ".($k-1).", " . $limit ; // исправил баг ".(($k-1)+$limit-1);
											$sql_validation = $sql_validation_original . " LIMIT ".($k-1).", " . $limit; // исправил баг ".(($k-1)+$limit-1);
											$parentIDdesc = $GLOBALS['id']; //переименовываем родителя
											$GLOBALS['id'] ++;  //генерируем следующий уник. элемент...
											$flag_select = 1;
										}
										//$create_folder_flag = 1;
										
								}
							
							
					
								
								
								#if ($limit > 0)
								#exit();
								//for ($i = 0; $k < )
							
							//print $limit = ($ts_ar[$key . "."]['settings.']['limit'] == 1) ? " LIMIT 0, 100" : null;
							
							//SELECT count(uid) as result_count FROM {$val} {$where} {$order}
							//
							//
									
									
									//Создаем папочку с данным количеством
									
									
									
									//return $CHILDREN_ARRAY;
									
									//
									//exit();
									//
					
								
								
								
								
						//если разрешено показывать данные	
						if ($flag_select == 1):
							
								// (TS-config) 
								//++++++++++++++++++++++++++++++++++//
								//++++++++++++++++++++++++++++++++++//
								//устанавливаем по умолчанию pid-хранилища в котором будем размещать новые записи
								//логика такая - если записи сущесвтуют - мы будем втсавить pid ихний
								//если запись выводится как "0-результ" - то будет втавляться Pid-родительской таблицы...
								if (strstr($ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'], "~") AND strstr($ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'], "!") == false) ////наследовать...
								$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'] = $damp_parent['pid']; //(меняем значение для панелиадминистрирования)//
								//++++++++++++++++++++++++++++++++++//
								//++++++++++++++++++++++++++++++++++//
								
								
								
								// NEW (start) - визуально отображение доступности дочерних элементов: 07.08.2013
								// Проверяем элементы на предмет включенности/выключенности/удаленности
								// Собираем информацию - пишем id-шки...
								$resValidationClause = $GLOBALS['TYPO3_DB']->sql_query ($sql_validation);// or die ( $GLOBALS['TYPO3_DB']->sql_error() );
								$elemvalValidationClauseData = null;
								while ($elemvalValidationClause = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resValidationClause) )
								{
									// пишем массив
									$elemvalValidationClauseData[ $elemvalValidationClause['uid'] ] = 1; // доступен
								}
								// NEW (end): 07.08.2013
								
								
								$res = $GLOBALS['TYPO3_DB']->sql_query ($sql);// or die ( $GLOBALS['TYPO3_DB']->sql_error() );
								$sql_error =  $GLOBALS['TYPO3_DB']->sql_error(); //Если есть ошибки (для нулевых результатов)
								$sql_error = ($sql_error != null) ? "<br /><div class='mysql-error'><b>Mysql-error:</b> ".$sql_error."</div>" : null;
								
								if ($GLOBALS['TYPO3_DB']->sql_num_rows ($res) > 0):

									// (TS-config) разбивка по условиям (часть I)
									if (	$ts_ar[$key . "."]['case.']  ) {
						
						
										
											
											//$start = microtime(true);
											//$time = microtime(true) - $start; // тело скрипта 
											//printf('Скрипт выполнялся %.4F сек.', $time);
											$code_php_to_eval = $setcase = null;
											foreach ($ts_ar[$key . "."]['case.'] as $casekey => $condition){
												
															/*
																	
																	1.case.a = iblock_type = 'standart'
																	
																	$xxx = 'return ( date("N",$date) == 1 ? TRUE : FALSE );';
																	eval(
																	"if (1==1){".
																	"echo ('abc');".
																	"}");
																	
																
															
															*/
															
															
													////\((.+) [\s]*=
													//([^=]+)
													#print $condition . "<BR />"; //собираем PHP-код
													$temp = preg_replace("/~([\w]+)[\s]/", '\$elemval[\'\\1\'] ', $condition);
													$code_php_to_eval .= " if ( {$temp}  ) {  \$setcase = '".$casekey.'\';  }';
													#print preg_replace("/([\w]+)[\s]/", " if (\$elemval['\\1']) { \$setcase = '\$casekey.'  } ", $condition) . "<br />";
											
											}		
															
									#	print $code_php_to_eval;
									#		print "<pre>";
									#	print_r(	$ts_ar[$key . "."] );
									#	print 1;
									#	exit();
										
										}

								
						
								while ($elemval = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res) )
								{
									/*
										new 08.08.2013
										ПРОВЕРКА ПРАВ ДОСТУПА НА
										ТАБЛИЦУ (возможность просмотра, возможность изменения) | ХРАНИЛИЩЕ
									*/
									$checkAccessUserArray = $this->checkAccessUser($damp_parent, $val, $elemval['pid']);
									$access_string_for_panelmoderation = $checkAccessUserArray['key'];
									
									
								
									// (TS-config) 
									//++++++++++++++++++++++++++++++++++//
									//++++++++++++++++++++++++++++++++++//
									//устанавливаем по умолчанию pid-хранилища в котором будем размещать новые записи
									//логика такая - если записи сущесвтуют - мы будем втсавить pid ихний
									//если запись выводится как "0-результ" - то будет втавляться Pid-родительской таблицы...
									$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'] = $elemval['pid']; //(меняем значение для панелиадминистрирования)//
									//++++++++++++++++++++++++++++++++++//
									//++++++++++++++++++++++++++++++++++//
									
									// (TS-config) разбивка по условиям (часть II)
									// если у нас существют разбивки по условиям мы выполняем подготовленные условия и результат выводим в переменную $setcase
									$setcase = null;
									if (	$ts_ar[$key . "."]['case.']  ) {
										
										/* 
										
											Пример  
											<?php
												
												if ( $elemval['iblock_type'] == 'standart' ) {  $setcase = 'a.'; } 
												if ( $elemval['iblock_type'] == 'modification' ) { setcase = 'b.'; } 
												if ( $elemval['iblock_type'] == 'system' ) { $setcase = 'c.'; }
											 
											 ?>
											
										*/
										eval( " {$code_php_to_eval} " ); //выполняем под с условиями...
									
									
									
										
										#print "<pre>";
										#print_r( $ts_ar );
										#print $code_php_to_eval;
										#print $elemval['title'];	exit();
										
									}
								
									//Собираем конфигурация панели администрирования
									////////////////////////////////////////////////////
									//$ts_ar[$key . "."]['panelmoderation.']['newdef_varpid'];
									//json_encode | serialize | var_export
									#$ar_newdefvar = serialize($ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']);// panelmoderation.new.defvar.;
									$ar_newdefvar = $this->serialize_myfunc($ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']);
									$addprefix_ifinsert_into = "panel-material-if-insert-into: [".$relationfieldvalue_green_save."] => ".$elemval['uid'];
									$addprefix_ifupdate_parent = "panel-material-if-ifupdate-parent: [".$table_parent."][".$parent_element."] => " . $relationfieldvalue_blue_save;
									#$ar_newdefvar = str_replace('\r\n', null, $ar_newdefvar); //удаляем переносы строк
									
									
										#if ($GLOBALS['count']++ > 50)
										#break;
									//1. записываем данные о текущем элементе
									//уникальный ключ данных (это нужно для проверки, грузить дочек или нет, а также для обращения в панели инструментов)
									if ($val == "tx_board_bonding") $UNICALE_key_inAllTree = "table_{$val}_{$uidboard}"; else //специальный ключ для досок - т.к. нет необходимости их перегружать лишними данными
									$UNICALE_key_inAllTree = "table_{$val}_".$elemval['uid']."_{$key}_{$parent_element}"; //здесь вставлено как можно больше значений, что бы избежать путанницы
									$INPUT_HIDDEN_PANELMODERATION_VALUE = "board:{$uidboard}|table:{$val}|uid:".$elemval['uid']."|pid:".$elemval['pid']."|relation_color:{$color}|panel:".$ts_ar[$key . "."]['panelmoderation']."|panel-fieldname:{$titleName}|panel-newdefvar:{$ar_newdefvar}:panel-newdefvar-end|{$addprefix_ifinsert_into}|{$addprefix_ifupdate_parent}|access_string:" . trim($access_string_for_panelmoderation)."|panel-eventdisabled:" . $ts_ar[$key . "."]['panelmoderation.']['eventdisabled']."|panel-dialog:" . $ts_ar[$key . "."]['panelmoderation.']['dialog']; //(TS-config) данные для панели администирования
									$CHILDREN_ARRAY[] = array ('title' => $elemval[ $titleName /*'title'*/], 'table' => $val, 'damp' => $elemval,
									
										"pid" => ($parentIDdesc == 0) ? 0 : $parentIDdesc,
										"id" => $GLOBALS['id'], //id-pid в рамках доски
										"levelOnlyGreenTree" => $level, //указываем level (уровень вложенности) -для зеленых веточек
									
									"where_ignore_pid" => $ts_ar[$key . "."]['settings.']['where_ignore_pid'],
									"border-color" => $ts_ar[$key . "."]['settings.']['border-color'], //цвет бордюра (TS-config)
									"relation_color" => $color,
									"noActiveTreeBranch" => (($elemvalValidationClauseData[ $elemval['uid'] ] <= 0 ) ? 1 : 0 ), // 1-значит визуализирует ветку данного элемента - как не активную...
									"toooltip_info" => array(
												
														//справочная информация для всплывающей подсказки и другого
														'user_access' => $checkAccessUserArray['string'], // права доступа на доску - Отправляем для отображения
														'is_lock_board' => $ts_ar[$key . "."]['system.']['lock'], //если доска заблокирована - просто добавляем замочек
														'tooltiprow' => $ts_ar[$key . "."]['settings.']['tooltiprow'],//поля на подсказку...
														'descriprow' => $ts_ar[$key . "."]['settings.']['descriprow'],//поля на описание...
														'commentary' => $elemval[$ts_ar[$key . "."]['settings.']['commentary']],//комментарий (выводится на против элемента через "-" если не будет флажок подробных данных...
														'sql_query' => $sql, //mysql-запрос к базе данных на выборку данного элемента
														'sql_validation' => $sql_validation, //mysql-запрос на проверку доступности элемента (вкл., выкл., удаленость в коризун)
														'UNICALE_key_generation' => $UNICALE_key_inAllTree, //уникальный ключ
														'PANELMODERATION_value' => ($ts_ar[$key . "."]['panelmoderation'] == 1) ? $INPUT_HIDDEN_PANELMODERATION_VALUE : "board:{$uidboard}|table:{$val}|panelModerationIsUndefined", //для панели
														//'countelements' => ($CHILDREN_this_count + $CHILDREN_external_count)
												
										)
									);
									
									end($CHILDREN_ARRAY); //это нужно для счетчика (перемещяем в конец указатель)
									$nowElemKey = key($CHILDREN_ARRAY); // получаем теку. ключ в массиве, что бы потом переписать значение кол-ва элементов
									$GLOBALS['id']++; //генерируем следующий уник. элемент...
								
								
								
									///////////////////////////////////////////
									//ВРЕМЕННО (если доска заблокирована - выходим
									//Это актуально только для досок на "0" уровне
									///////////////////////////////////////////
									if ($ts_ar[$key . "."]['system.']['lock'] == 1)
									continue;
									
								
									//2. Запись о прикрепленных данных по внутреннему построению дерева
									//Если у нас требуется построение внутреннего дерева
									//вариант 3 (ЗЕЛЕНЫЕ ВЕТОЧКИ) - связь построения дерева из одной таблице
									if (isset($relationmethod['this']))
									{
										//Передаем тот-же массив что и сейчас работает у нас
										#ЗДЕСЬ ЭТО НЕ АКТУАЛЬНО->if ($setcase != null) $key = $setcase; //Если у нас определено ключ уловия - меняем основной ключ - погружаемся...
										$tmp = array ($key => $ts_ar[$key], $key."." => $ts_ar[$key."."]);
										$tmp[$key . "."]['relation.']['field.']['this.']['startpoint'] = $elemval['uid']; //устанавливаем новое стратовое значение
										$tmp[$key . "."]['settings.']['folder'] = null; //удаляем повторное использование папки (повторной оборачиваемости)...
										$tmp[$key . "."]['relation.']['field.']['this.']['datafirstlevel'] = null; //удаляем прикрепление данных в 0 уровень (уровень startpinter)...
												
										////уникальный ключ данных (это нужно для проверки, грузить дочек или нет, а также для обращения в панели инструментов)
										//$pdampsend = ($ts_ar[$key . "."]['settings.']['dampclear'] == 1) ? null : $elemval; //если требуется не отпровлять данные о родителе дочкам
										$CHILDREN_ARRAY_this = ( $this->searchUNICALE_key( $UNICALE_key_inAllTree )) ? $this -> bildTree($uidboard, $tmp, false, $damp_parent, null, $GLOBALS['id']-1, $level+1, $val) : null; //если ключ на открытие найден выбираем детей
										$CHILDREN_this_count = $this -> bildTree($uidboard, $tmp, false, $damp_parent, 'todo_countelements');	
									
										//СУММИРУЕМ.Добавлляем в общий массива
										//-foreach - работал очень МЕДЛЕННО... - видать из-за создания массива.......
										for ($i = 0; $i < count($CHILDREN_ARRAY_this); $i++)  //прикрепленные внешние данные
										$CHILDREN_ARRAY[] = $CHILDREN_ARRAY_this[$i];	
										#foreach ($CHILDREN_ARRAY_this as $number => $value)		//внутреннее постооение дерева
										#$CHILDREN_ARRAY[] = $CHILDREN_ARRAY_this[$number];
									}
									
									
										///////////////////////////////////
										//ЕСЛИ НАС ПРОСЯТ ВСТАВИТЬ SEPARATOR
										///////////////////////////////////
										//if ($CHILDREN_this_count > 0 and $relationmethod['this.']['separator'] == 1)
										
									
												
										//3. Запись о прикрепленных данных
										//уникальный ключ данных (это нужно для проверки, грузить дочек или нет, а также для обращения в панели инструментов)
										//$pdampsend = ($ts_ar[$key . "."]['settings.']['dampclear'] == 1) ? null : $elemval; //если требуется не отпровлять данные о родителе дочкам
										if ($setcase != null) {
										
											//если условие выполняется погружаен на уровень ниже...
											#$setcase : $key; //Если у нас определено ключ уловия - меняем основной ключ - погружаемся...
											#$ts_ar[$key."."] = $ts_ar[$key."1."][$setcase."."];
											$ts_ar_external[$key."."] = $ts_ar[$key."."][$setcase."."];
										
										} else { $ts_ar_external = $ts_ar; }
										$CHILDREN_ARRAY_external = ( $this->searchUNICALE_key( $UNICALE_key_inAllTree )) ? $this -> bildTree($uidboard, $ts_ar_external, $key . ".", $elemval, null, $GLOBALS['id']-1-count($CHILDREN_ARRAY_this), false, $val) : null; //если ключ на открытие найден выбираем детей
										$CHILDREN_external_count = $this -> bildTree($uidboard, $ts_ar_external, $key . ".", $elemval, 'todo_countelements'); //если ключ на открытие найден выбираем детей
										
										//-foreach - работал очень МЕДЛЕННО... - видать из-за создания массива.......
										for ($i = 0; $i < count($CHILDREN_ARRAY_external); $i++)  //прикрепленные внешние данные
										$CHILDREN_ARRAY[] = $CHILDREN_ARRAY_external[$i];	
										#foreach ($CHILDREN_ARRAY_external as $number => $value)  //прикрепленные внешние данные
										#$CHILDREN_ARRAY[] = $CHILDREN_ARRAY_external[$number];
										
												//Объединяем массивы если нет пустых значений)
												//if ($CHILDREN_this['error-num-result'] == null AND $CHILDREN_external['error-num-result']):
												
													
												
												//else:
												
													//Есть сообщения о том, что элементы не найдены
													//Если существуют пустые значения (группируем их, что бы не выводить по несколько раз одно и тоже соощение элементы не найдены
													//За исключением случаем, когда они разбиты на папки #goto-34949
													
													
												//endif;
											
													
													
													//if(count ($CHILDREN_result['error-num-result'])
													
											
										//переписываем значение рузультатов кол-ва элементов
										$countelements = $CHILDREN_this_count + $CHILDREN_external_count;
										$CHILDREN_ARRAY[$nowElemKey]['toooltip_info']['countelements'] = ($countelements == null) ? 0 : $countelements;
										
										
										
										////////////////////////////////////////////////////
												
													
											//сохраняем таблицу для синих веток - т.к. им это потребуется...
											#$GLOBALS['table_parent'] = $val;
											$UNICALE_key_inAllTree = null;
									
									
										////////////////////////////////////////////////////
									
										//$i ++;
								}
					
								else: //Элементы не найдены
							
								  //Здесь собираем ошибки в кучу, что бы не выдавать по несколько раз сообщение элементы не найдены
								  //Будет так - элементы не найдены для tt_content_ pages tt_news sys_tamplate ...
							
								/////////////////////
								//this.nullresult - если у нас существует связь
								//и нас просят не выводить попочку и при условии что не помещяем в папочк
								//и при условии, что уровень не равен 0
								////////////////////
								
								//	$relationmethod['this.']['startpoint']
								// не выводим если нас просят...
								//if ($relationmethod['this.']['nullresulthide'] == 1 and $level > 0 and $create_folder_flag == 0){} 
								if ($relationmethod['this.']['nullresulthide'] == 1 and $level > 0 and $create_folder_flag == 0){} 
								else {
									
									/*
										new 08.08.2013
										ПРОВЕРКА ПРАВ ДОСТУПА НА
										ТАБЛИЦУ (возможность просмотра, возможность изменения) | ХРАНИЛИЩЕ
									*/
									$checkAccessUserArray = $this->checkAccessUser($damp_parent, $val, $ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid']);
									$access_string_for_panelmoderation = $checkAccessUserArray['key'];
									
									
									//Собираем конфигурация панели администрирования
									////////////////////////////////////////////////////
									//$ts_ar[$key . "."]['panelmoderation.']['newdef_varpid'];
									//json_encode | serialize | var_export
									#$ar_newdefvar = serialize($ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']);// panelmoderation.new.defvar.;
									$ar_newdefvar = $this->serialize_myfunc($ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']);
									$addprefix_ifinsert_into = "panel-material-if-insert-into: [".$relationfieldvalue_green_save."] => ".$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid'];
									$addprefix_ifupdate_parent = "panel-material-if-ifupdate-parent: [".$table_parent."][".$parent_element."] => " . $relationfieldvalue_blue_save;
									#$ar_newdefvar = str_replace('\r\n', null, $ar_newdefvar); //удаляем переносы строк
									
									//Здесь уникальный ключ нужен для id-всплявающих подсказок
									$UNICALE_key_inAllTree = "result_null_{$val}_{$i}_{$key}_{$parent_element}_".$parentIDdesc; //здесь вставлено как можно больше значений, что бы избежать путанницы
									$INPUT_HIDDEN_PANELMODERATION_VALUE = "board:{$uidboard}|table:{$val}|uid:-|pid:".$ts_ar[$key . "."]['panelmoderation.']['new.']['defvar.']['pid']."|relation_color:{$color}|panel:".$ts_ar[$key . "."]['panelmoderation']."|panel-fieldname:{$titleName}|panel-newdefvar:{$ar_newdefvar}:panel-newdefvar-end|{$addprefix_ifinsert_into}|{$addprefix_ifupdate_parent}|access_string:" . trim($access_string_for_panelmoderation)."|panel-eventdisabled:edit|deleted|hidden|panel-dialog:" . $ts_ar[$key . "."]['panelmoderation.']['dialog']; //(TS-config) данные для панели администирования
									$CHILDREN_ARRAY[] = array ('title' => 'Записи не найдены или отсутствуют <!--(таблица ' . $val . ')-->', 'typeElem' => "result_null",
														  
															"pid" => ($parentIDdesc == 0) ? 0 : $parentIDdesc,
															"id" => $GLOBALS['id'], //id-pid в рамках доски
														    'mysql-table' => $val,
															"relation_color" => $color,
															
															
															"toooltip_info" => array(
												
															//справочная информация для всплывающей подсказки и другого
															//'tooltiprow' => $ts_ar[$key . "."]['settings.']['tooltiprow'],//поля на подсказку...
															//'descriprow' => $ts_ar[$key . "."]['settings.']['descriprow'],//поля на описание...
															'user_access' => $checkAccessUserArray['string'], // права доступа на доску - Отправляем для отображения
															'sql_query' => $sql . $sql_error, //mysql-запрос к базе данных на выборку данного элемента
															'sql_validation' => $sql_validation, //mysql-запрос на проверку доступности элемента (вкл., выкл., удаленость в коризун)
															'UNICALE_key_generation' => $UNICALE_key_inAllTree, //уникальный ключ
															'PANELMODERATION_value' => ($ts_ar[$key . "."]['panelmoderation'] == 1) ? $INPUT_HIDDEN_PANELMODERATION_VALUE : "board:{$uidboard}|table:{$val}|panelModerationIsUndefined", //для панели
														
															//'countelements' => ($CHILDREN_this_count + $CHILDREN_external_count)
												
															)
													);
									$GLOBALS['id']++; //увеличиваем значение Id;
								}
								endif;
								
								
								
								////////////////////////////////////////////////////
								//ПРИКРЕПЛЕНИЕ РЕЗУЛЬТАТОВ В 0-уровень (уровень startpointer)
								////////////////////////////////////////////////////
								// (TS-config) - datafirstlevel - если просят вставить данные к стартовой точке...
								if ($relationmethod['this.']['datafirstlevel'] == 1 and $relationmethod['this.']['startpoint'] >= 0){
									
									
									//3. Запись о прикрепленных данных (- в точку 0-уровня - в точку startpoint)
									//уникальный ключ данных (это нужно для проверки, грузить дочек или нет, а также для обращения в панели инструментов)
									//$pdampsend = ($ts_ar[$key . "."]['settings.']['dampclear'] == 1) ? null : $elemval; //если требуется не отпровлять данные о родителе дочкам
									
										
									//для начала мы прубуем получить 0 уровень данные из бд
									//$elemval = array('uid' => $relationmethod['this.']['startpoint']); // $elemval = array('uid' => 0);
									$elemval_damp_0_level_startpoint = t3lib_befunc::getRecord($val, $relationmethod['this.']['startpoint'], $columnselect);
									
									//Если записи в root-не существует - то прерываем выполнение...
									if ($elemval_damp_0_level_startpoint == null)
									$elemval_damp_0_level_startpoint['uid'] = $relationmethod['this.']['startpoint'];
										
									$CHILDREN_ARRAY_external = $this -> bildTree($uidboard, $ts_ar, $key . ".", $elemval_damp_0_level_startpoint, null, $parentIDdesc, false, $val); //если ключ на открытие найден выбираем детей
									$CHILDREN_external_count = $this -> bildTree($uidboard, $ts_ar, $key . ".", $elemval_damp_0_level_startpoint, 'todo_countelements'); //если ключ на открытие найден выбираем детей
										
									//-foreach - работал очень МЕДЛЕННО... - видать из-за создания массива.......
									if ($CHILDREN_external_count > 0):
										for ($i = 0; $i < count($CHILDREN_ARRAY_external); $i++)  //прикрепленные внешние данные
										$CHILDREN_ARRAY[] = $CHILDREN_ARRAY_external[$i];	
										
										//переписываем значение рузультатов кол-ва элементов
										//$countelements = $countelements + $CHILDREN_external_count;
										//$CHILDREN_ARRAY[$nowElemKey]['toooltip_info']['countelements'] = ($countelements == null) ? 0 : $countelements;
									endif;
									
								}
								
								
								
								
								
								
								////////////////////////////////////////////////////
								//УТЕРЯННЫЕ/БИТЫЕ/НЕ ИСПОЛЬЗОВАННЫЕ ЭЛЕМЕНТЫ
								////////////////////////////////////////////////////
								// В ОБЩЕМ ЭТО ВСЕ ПЕРЕДЕЛЫВАТь!!!!!!!!!!
								
								/* $resb = $GLOBALS['TYPO3_DB']->sql_query ($sql_broken);// or die ( $GLOBALS['TYPO3_DB']->sql_error() );
								if ($GLOBALS['TYPO3_DB']->sql_num_rows ($resb) > 0): //если у нас найдены битые, утерянные или не использованные элементы
								
								//1. СОЗДАЕМ ПАПКУ
								//Пытаемся найти битые, утерянные элементы для данной веточки доски склеивания
								$CHILDREN_ARRAY[] = array ('title' => 'Обнаружены утерянные, битые либо не использованные элементы' . $val, 'typeElem' => "folder",
														  
															"pid" => ($parentIDdesc == 0) ? 0 : $parentIDdesc,
															"id" => $GLOBALS['id'], //id-pid в рамках доски
														    'mysql-table' => $val,
															"relation_color" => $color,
															
															"toooltip_info" => array(
												
															//справочная информация для всплывающей подсказки и другого
															//'tooltiprow' => $ts_ar[$key . "."]['settings.']['tooltiprow'],//поля на подсказку...
															//'descriprow' => $ts_ar[$key . "."]['settings.']['descriprow'],//поля на описание...
															//'sql_query' => $sql, //mysql-запрос к базе данных на выборку данного элемента
															//'sql_validation' => $sql_validation, //mysql-запрос на проверку доступности элемента (вкл., выкл., удаленость в коризун)
															//'UNICALE_key_generation' => rand(1,1000000000000000000), //уникальный ключ
															//'countelements' => ($CHILDREN_this_count + $CHILDREN_external_count)
												
															)
													);
								$parentIDdesc = $GLOBALS['id']; //переименовываем родителя
								$GLOBALS['id']++; //увеличиваем значение Id;	
								
								//2. НАПОЛНЯЕМ ПАПКУ...
								while ($elemvalb = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resb) )
								{
									
									//$UNICALE_key_inAllTree = "broken_table_{$val}_".$elemvalb['uid']."_{$i}_{$key}_{$parent_element}_".$parentIDdesc; //здесь вставлено как можно больше значений, что бы избежать путанницы
									$CHILDREN_ARRAY[] = array ('title' => $elemvalb[ $titleName ] . $level, 'table' => $val, 'damp' => $elemvalb,
									
										"pid" => ($parentIDdesc == 0) ? 0 : $parentIDdesc,
										"id" => $GLOBALS['id'], //id-pid в рамках доски
										
									"relation_color" => 'red',
									"toooltip_info" => array(
												
														//справочная информация для всплывающей подсказки и другого
														'tooltiprow' => $ts_ar[$key . "."]['settings.']['tooltiprow'],//поля на подсказку...
														'descriprow' => $ts_ar[$key . "."]['settings.']['descriprow'],//поля на описание...
														'sql_query' => $sql_broken, //mysql-запрос к базе данных на выборку данного элемента
														'sql_validation' => $sql_validation, //mysql-запрос на проверку доступности элемента (вкл., выкл., удаленость в коризун)
														'UNICALE_key_generation' => $UNICALE_key_inAllTree, //уникальный ключ
														//'countelements' => ($CHILDREN_this_count + $CHILDREN_external_count)
												
										)
									);
									//$GLOBALS['id']++; //увеличиваем значение Id;
									
								}
								
								endif; */
								
						//flag_select
						endif;
									
									
									////////////////////////////////////
									//РАЗЛИМИЧИВАНИЕ ДАННЫХ (завершение)
									////////////////////////////////////
									//print $sql . " LIMIT ".($i-1).", ".(($i-1)+$limit-1)." <br />";
									//print "Записи с " . $i . " по ".($i+$limit-1)."<br />";
									$k += $limit;
									
									
									//$sql = 
									
									//Останавливаем цикл...
									if ($k >= $row['result_count'] or $limit == null)
									break;
									
									
						}			
									
									
									
									
					$parentIDdesc = $oldparentIDdesc;//восстанавливаем значение родителя для след.ключа
				} //end if is_int
				
				
						
	
			
		}
	
		//Если мы считаем кол-во элементов
		if ($systemevent == "todo_countelements")
		return $row_count; //return ($row_count > 0) ? $row_count : 0;
		else
		return $CHILDREN_ARRAY;
		
	}
	
	// вспомогательная функция - проверятет прова доступа на таблицу, хранилище
	// возвращяет два массива - один ключи доступа (кода), другой строку для HTMl
	function checkAccessUser($damp_parent, $val, $pid){ // $val - это название таблицы
	
	
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
					/*
										ПРОВЕРКА ПРАВ ДОСТУПА НА
										ТАБЛИЦУ (возможность просмотра, возможность изменения) | ХРАНИЛИЩЕ
								
					 // Read (r) - чтение
					 // Write (w) - модификация и изменение
									
									print "Просмотр таблицы" . $GLOBALS['BE_USER']->check('tables_select','tt_content_catalog_pdf');
									print "Модификация таблицы" . $GLOBALS['BE_USER']->check('tables_modify','tt_content_catalog_pdf');
									print "Доступ на поле pelem" . $GLOBALS['BE_USER']->check("non_exclude_fields","tt_content_catalog_pdf:photo_preview");
										
									// Права доступа на страницу...
									#$perms_clause = $GLOBALS['BE_USER']->getPagePermsClause(4);
									#print $perms_clause;
									#$pageinfo = t3lib_BEfunc::readPageAccess('119',$perms_clause);
									
									print "<hr>";
									
									$perms_clause_1 = $GLOBALS['BE_USER']->getPagePermsClause(1);
										$perms_clause_2 = $GLOBALS['BE_USER']->getPagePermsClause(2);
											$perms_clause_4 = $GLOBALS['BE_USER']->getPagePermsClause(4);
												$perms_clause_8 = $GLOBALS['BE_USER']->getPagePermsClause(8);
													$perms_clause_16 = $GLOBALS['BE_USER']->getPagePermsClause(16);

									print "<pre>";
									print "Пользователь может чтение pages " .  print_r(t3lib_BEfunc::readPageAccess(119,$perms_clause_1), true) . "<br />";
									print "Пользователь может править содерижмое pages " .  print_r(t3lib_BEfunc::readPageAccess(119,$perms_clause_16),true) . "<br />";
									print "Пользователь может редактировать pages " .  print_r(t3lib_BEfunc::readPageAccess(119,$perms_clause_4),true) . "<br />";
									print "Пользователь может редактировать pages " .  print_r(t3lib_BEfunc::readPageAccess(119,$perms_clause_4),true) . "<br />";
									print "Пользователь может создавать новые pages " .  print_r(t3lib_BEfunc::readPageAccess(119,$perms_clause_8),true) . "<br />";
									
									print "Пользователь может чтение pages " . $GLOBALS['BE_USER']->doesUserHaveAccess(119,1) . "<br />";
									print "Пользователь может просмотривать pages " . $GLOBALS['BE_USER']->doesUserHaveAccess(119,2) . "<br />";
									print "Пользователь может редактировать pages " . $GLOBALS['BE_USER']->doesUserHaveAccess(119,4) . "<br />";
									
									
									print "<pre>";
									print_r($pageinfo);
									exit();
					*/
									
									// Очищаем переменные...
									$access_1 = $access_2 = $access_3 = $access_not = null;
									$access_string_for_panelmoderation = null;
									$ts_ar[$key . "."]['system.']['lock'] = 0;
										
									//if ($damp_parent != null) {// так мы пропускаем саму доску...доски "0" уровень не проверяем "tx_board_bonding"
									 
									 
										// Проверяем права на чтение таблицы
										if ($GLOBALS['BE_USER']->check('tables_select', $val) == 1){
										
											$access_1 = " <span class='all_accesss_type r'>R-table</span> "; 
											$access_string_for_panelmoderation .= "R"; // собираем строку прав для панели
										}
										else {
											
											// Если нет прав
											// $ts_ar[$key . "."]['system.']['lock'] = 1; // запрещяем чтение ветки дерева далее
											$access_1 = " <span class='all_accesss_type r not'><s>R</s>-table</span> "; 
										
										}
											
										// Проверяем права на изменение таблицы
										if ($GLOBALS['BE_USER']->check('tables_modify', $val) == 1){
										
											$access_2 = " <span class='all_accesss_type w'>W-table</span> ";
											$access_string_for_panelmoderation .= "W"; // собираем строку прав для панели
										
										}
										else {
										
											// Если нет прав
											// Запрещяем панель администрирования тем самым...
											// $ts_ar[$key . "."]['system.']['lock'] = 1;
											$access_2 = " <span class='all_accesss_type w not'><s>W</s>-table</span> ";
										
										}
											
										// Проверяем доступ на хранилище (возможность чтения записей)
										$perms_clause_16 = $GLOBALS['BE_USER']->getPagePermsClause(16); // 1-единица - возможность чтения // 16-возможность править содержимое
										$access = t3lib_BEfunc::readPageAccess($pid,$perms_clause_16);
										
										if (is_array($access) == 1){
										
											$access_3 = " <span class='all_accesss_type s'>S</span> ";
											$access_string_for_panelmoderation .= "S"; // собираем строку прав для панели
										
										} else {
											
											if ($pid <= 0) // если не удалось определить хранилище
											$access_3 = " <span class='all_accesss_type w not'><s>S</s> - не удалось определить хранилище - т.к. значение даже не = 0</span> ";
											else
											$access_3 = " <span class='all_accesss_type w not'><s>S</s></span> ";
										
										}
										
										//xxxx
										
											// Особое для таблиц (пока beta)
											if ($val == "pages" )
											$access_special = " <span class='all_accesss_type' style='background-color: blue;'>Специальное для pages (beta)</span> ";
											
											
											// Особое для таблиц (пока beta)
											if ($val == "tt_content" )
											$access_special = " <span class='all_accesss_type' style='background-color: blue;'>Специальное для tt_content (beta)</span> ";
											
											
										return array (
										
											'key' => $access_string_for_panelmoderation,
											'string' => $access_1 . $access_2 . $access_3 . $access_special		
														
										);
										// Примрепляем права к названию элемента - Собираем результат о проверке на права в одно целое
										// $elemval[ $titleName /*'title'*/] = $elemval[ $titleName /*'title'*/] .;
									
									//}
		//is_lock_board
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////
	}
	
	//вспомогательная функция - написанная мной
	//serialize - т.к. с ним у меня не получилось преобразовать строку, сделал так...
	function serialize_myfunc($array){
	
		//Собарикем строк
		#foreach ($array as $key => $value) > - долго работает...
		#$string .= $key."=".$value.";";
		
		//Возвращяем
		#$keys = array_keys($array);
		#$values = array_values($array);
		
		#for ($i = 0; $i < count ($keys); $i++)
		#$string .= $keys[$i]."=".$values[$i].";";
		$string = print_r($array, true);
		$string = str_replace(array("\n", "\r"), null, trim($string));  //удаляем переносы строк (это необходимо, т.к. используем input text
		//http://stackoverflow.com/questions/3760816/remove-new-lines-from-string
		#$string = preg_replace('/\s+/', null, trim($string)); //удаляем переносы строк
		//$string = str_replace('\n', null, $string);
		return $string; // "(".$string.")"
			
	}
	
	/**
 * Возвращает html код дерева
 * @param  array    $tree - массив в формате array(array('name' => .., 'id' => .., 'pid' => ..), array(..))
 * @param  integer  $pid - id родителя
 */
 	// Выпуск дерева 
function htmlTree($boardUid, $tree, $pid, $level = 0, $noActiveTreeBranch = 0) // неактивная ветка далее по дереву (если установлена 1-единица)...
{
	global $pref;
	//$content = '';
	
	//print "<pre>";
	//foreach ($tree as $key => $val)
	//print $val['pid']."<br/>";
	
	//PRINT_R($tree);
	//exit();
	
	for ($i = 0; $i < count ($tree); $i++)
    //foreach ($tree as $row)
    {
		$row = $tree[$i];
        if ($row['pid'] == $pid)
        {
		   $tree[$i]['include_output'] = 1; //помечаем данные уже как включенный в вывод элемент (это нужно для поиска)
		   //$content .=  '<li><div class="allpanelelement" style="border-left: red 5px solid;" idBoard="'.$boardUid.'" pattern="'.$row['toooltip_info']['UNICALE_key_generation'].'" 
		   //isOpen="'. (($this->searchUNICALE_key( $row['toooltip_info']['UNICALE_key_generation'] ) == 1)? 'yes':'no')  .'">';
			
			// NEW (start) - визуально отображение доступности дочерних элементов: 07.08.2013
			// Проверяем элемент на предмет включенности/выключенности/удаленности
			// Если он не доступен - визуально затемняем его..
			// Присвоив определенный класс...
			// Лалее тоже вся ветка будет не активной
			// Здесь предположение основывается на том, что чем глубже , тем меньше вероятность, что документ будет получен во FE
			if ($row['noActiveTreeBranch'] == 1 OR $noActiveTreeBranch[$row['pid']] == 1){
			
				// Если это дерево, делаем чем глубже тем выше opacity
				# [поддержка исключена] $cssClass_noActiveTreeBranch = " noActiveTreeBranchDiv level_" . (($row['levelOnlyGreenTree']>5)?'next':$row['levelOnlyGreenTree']) . " ";
				$noActiveTreeBranch[$row['id']] = 1;
				
			}
			else {
				$noActiveTreeBranch = null;
				# [поддержка исключена] $cssClass_noActiveTreeBranch = null;
			}
			// NEW (end): 07.08.2013
			
			
				$add = "";
			
				//Веточки выводим при условии, что уровень больше 0
				if ($level > 0):
				for ($j = 0; $j < $level; $j ++)
				$add .= $pref[$j];
				
				//Если есть сестры
				if ( $this->searchNextSister($tree, $i) == 1)
				{
					//Приходиться проверять, есть дочки, или нет - если есть, мы выводим возможность раскрыть родителя
					//$isOpen = (count ($ar[$i]['tmp']) > 0) ? "minus" : "plus";
					$add .= '<span class="join"></span>';
					$pref[$level] = '<span class="line"></span>';
					//$add .= "|-"; //$pref[$level] = "-";
				}
				else 
				{
					//Приходиться проверять, есть дочки, или нет - если есть, мы выводим возможность раскрыть родителя
					//$isOpen = (count ($ar[$i]['tmp']) > 0) ? "minusonly" : "joinbottom";
					$add .= '<span class="joinbottom"></span>';
					$pref[$level] = '<span class="blank"></span>'; //Чистая иконка;
					//$add .= "|_"; //$pref[$level] = "|";
				}
				endif;
			
				
				//Веточки дерева
				//$content .= $add;
				
				
				//Если синие ветки - сообщаем в дерево, что данные взяты от родителя
				//$tmpBlue = ($ar[$i]['flagBlueTree'] == 1) ? "<b style='color: blue'>*</b>" : null;
				
				//$content .= '<img alt="" src="http://localhost:8505/typo3/gfx/clear.gif" class="x-tree-ec-icon x-tree-elbow-minus">';
				
				//$isOpen = 'minus';
				//$simbol .=   $icon = '<img' . t3lib_iconWorks::skinImg($this->backPath, 'gfx/ol/' . ($isOpen ? 'minus' : 'plus') . 'only.gif', 'width="18" height="16"') . ' alt="" />';
			
				//$isOpen ='plus';
				//$content .=   $icon = '<img' . t3lib_iconWorks::skinImg($this->backPath, 'gfx/ol/plusonly.gif', 'width="18" height="16"') . ' alt="" />';
					
					//Если запись заблокирована, ее кто-то начал реактировть...
					if ($lockInfo=t3lib_BEfunc::isRecordLocked($row['table'], $row['damp']['uid'])){
					
						$iconLock = " " . t3lib_iconWorks::getSpriteIcon('status-warning-in-use') . " ";
						$iconLock .= " [<b>".$lockInfo['username'] ." </b> - ".date("Y-m-d H:i:s" , $lockInfo['tstamp'])."]";
						
					}
					else $iconLock = null;
					
					
					
				//Ссылка на раскрытие/скрыте дерева
				$linkdocument = $this->isOpenOrClose_compile_link ( $row['toooltip_info']['UNICALE_key_generation'] );
				$tooltip = $this -> createcontentTooltip ( $row,  $row['relation_color'], $row['toooltip_info']['tooltiprow'], $lockInfo, $row['toooltip_info']['PANELMODERATION_value']);  //Создаем контент для всплывающую подсказку...
				$descrip = $this -> createcontentDescrip ( $row['table'], $row, $row['toooltip_info']['descriprow']);  //Создаем подробное описание из набора полей...
					
					// [поддержка исключена - пока просто оставлено!] Если это разделитель (Separator)
				if ($row['damp']['is_special_board_platform'] == 3){
					$content .=  '<li style="position: relative;" class="is_special_board_platform_3"><div class="notClicked xDbMySQL_class_separator" style="border-left: black 3px solid; text-align: center; "  >';
					//$content .= "<input class='panelmoderation_element_value' disabled type='hidden' value='".$row['toooltip_info']['PANELMODERATION_value']."'>";

						// вывод id-хранилища (pid)
					$content .= "<span class='dop-information' style='position: absolute; top: 6px; left: 9px;'>";
					$content .= "<input type='button' value='Хранилище: ".$row['damp']['pid']."' class='idElement' style='margin-top: -2px; margin-right: 12px;'>";
					$content .= "</span>";

					$content .= "<span class='wrapcontentprimary' style='float: none; color: white; text-align: center; font-weight: bold;'>";
					$content .= "&nbsp;".$row['damp']['title']."</span>";
					$content .= "<div
					class='is_special_board_platform_3_link_edit'
					style='position: absolute; right: 3px; top: 5px; color: white;'>
					<a href='/typo3/alt_doc.php?returnUrl=".urlencode("mod.php?&M=web_txtestM1&id=0")."&edit[tx_board_bonding][".$row['damp']['uid']."]=edit'>
					Редактировать " . t3lib_iconWorks::getSpriteIcon( 'actions-page-open' ) . "
					</a></div>";
				}
				
				//Иконка, название, иконка-блокировка
				elseif ($row['damp']['uid'] > 0){
					
					// New 06.05.2014
					// Прогоняем через спец.функцию // Выводим title-через TYPO3-функцию
					$titleOrig = t3lib_BEfunc::getRecordTitle($row['table'],$row['damp'],FALSE,TRUE);
					$row['title'] = $titleOrig;
					
						//Если название элемента не задано
						if (trim($row['title']) == null)
						$row['title'] = "-";
						// $row['title'] = "<s>Название элемента #".$row['damp']['uid']." не задано!</s>";
					
						// Оберкта для титле
						$row['title'] = $this->smarty_modifier_mb_truncate($row['title'], 75); //обрезаем строку
						$row['title'] = " <span class='label'>".$row['title']."</span>";
				
						// Если это страницйа (таблица pages)
						// добавляем ссылку на редактировать содержимое страницы
						// /typo3/sysext/cms/layout/db_layout.php?id=48&
						if ($row['table'] == "pages"){
						
						preg_match_all("/panel-eventdisabled:([a-z|]+)/i", $row['toooltip_info']['PANELMODERATION_value'], $matches_eventdisabled);
						if (strstr($row['toooltip_info']['PANELMODERATION_value'], "|panel:1|")){ // если панель не задана и если событие не числиться в запрещенных
						if (!strstr($matches_eventdisabled[1][0], "pageContent")){
								$row['title'] .= "&nbsp; <span onclick=\"window.open('/typo3/sysext/cms/layout/db_layout.php?id=". $row['damp']['uid']."')\">";
								$row['title'] .= t3lib_iconWorks::getSpriteIcon( 'actions-page-open' );
								$row['title'] .= "</span>";
							
								#print "<pre>";
								#print_r($row['toooltip_info']['PANELMODERATION_value']);
								#exit();
							}
						}
						}
				
					//Если цвет пустой - задаем белый по умолчанию
					if ($row['border-color'] == null)
					$row['border-color'] = "gray";
					
					#$isOpen = 'minus';
					##	$isOpen ='plus';
					#$this->content .=  '<img' . t3lib_iconWorks::skinImg($this->backPath, 'gfx/ol/plusonly.gif', 'width="18" height="16"') . ' alt="" />';
					#print "<pre>";
					#print_r( $row );
					#exit();
			
					//Если эта запись является недавно добавленной - помечаем ее специальным классом
					$this_is_new = ($this -> last_news_records_add[ $row['table'] ][$row['damp']['uid']] == 1) ? "  - <span class='newelement'><b>новый!</b></span>" : null;
					//ibackground-color: red; f ()
			
					//Если есть комментарий к записи ... system_note
						
							// Цвет комментария
						if ($row['table'] == "tx_board_bonding")
						$temp_color = "  #e9e9e9 ";
						else { $temp_color = " gray "; }
					
					$row['toooltip_info']['commentary'] = $this->smarty_modifier_mb_truncate($row['toooltip_info']['commentary'], 50); //обрезаем строку
					$commentary = (trim($row['toooltip_info']['commentary']) != null) ? " <span style='color: {$temp_color};' class='dop-information'> - " . strip_tags($row['toooltip_info']['commentary']) . "</span>" : null;
					
					// Если это доски (делаем им плашечки серенькими как на xDbMySQL)
					if ($row['table'] == "tx_board_bonding")
					$xDbMySQL_class = "  xDbMySQL_class ";
					else { $xDbMySQL_class = null; }
					
					$content .=  '<li><div class="allpanelelement canselect '.$xDbMySQL_class.'" style="border-left: '.$row['border-color'].' 3px solid;" idBoard="'.$boardUid.'" pattern="'.$row['toooltip_info']['UNICALE_key_generation'].'" ';
					$content .=  'isOpen="'. (($this->searchUNICALE_key( $row['toooltip_info']['UNICALE_key_generation'] ) == 1)? 'yes':'no')  .'">';
					$content .= "<a href='{$linkdocument}' class='ajaxloadbranch canselected'>"; //ссылка на октрыть, закрыть
					$content .= "<span class='wrapcontentprimary'><span class='".$cssClass_noActiveTreeBranch."'>{$simbol}&nbsp;"; // cssClass_noActiveTreeBranch - если ветка далее идет не активной из-за вкл.,выкл., удаленности в корзину родительского элемента...
					//$content .=  '<img style="position: absolute; margin-left: -23px; margin-top: 2px;" ' . t3lib_iconWorks::skinImg($this->backPath, 'gfx/ol/plusonly.gif', '') . ' alt="" />';

						// Кол-во элементов, если [>0] - выводим черным, если [=0] - серым
					$csscolor = ( $row['toooltip_info']['countelements'] >= 1 ) ? 'black' : 'gray'; 
					
						// Выводим данные для панели
					$content .= "<input class='panelmoderation_element_value' disabled type='hidden' value='".$row['toooltip_info']['PANELMODERATION_value']."'>";

						// вывод id-хранилища (pid)
						// по данному элементу делается смещение подсказки в jQuery
						// если выборка производится с where_ignore_pid - то делаем красным и пищем игнорируется
					$content .= "<span class='dop-information'>";
					if ($row['where_ignore_pid'] == 1) {
						$content .= "<input type='button' value='Хранилище - игнорируется: ".$row['damp']['pid']."' class='idElement' style='color: red; margin-top: -2px; margin-right: 8px;'>";
					} else {
						$content .= "<input type='button' value='Хранилище: ".$row['damp']['pid']."' class='idElement' style='margin-top: -2px; margin-right: 8px;'>";
					}
					$content .= "</span>";

						// Выводим иконку
					$content .= $add . " ";
					$content .= t3lib_iconWorks::getSpriteIconForRecord($row['table'], $row['damp'], array(
																					 //'title' => htmlspecialchars($ar[$i]['toooltip_info']['sql_query']),
																					 'fortooptipkey' => 'tooptip_'.$row['toooltip_info']['UNICALE_key_generation'], //какую вспл.подсказку показать
																					 'class' => 'c-recIcon',
																					 'style' => '',
																					
																				));

						// Если доска заблокирована (выключена) или если запись уже редактируется кем-то
					$content .= $iconLock;
					$content .= ($row['toooltip_info']['is_lock_board'] == 1) ? " <img src='".t3lib_extMgm::extRelPath('boards') ."mod1/icon/lock-warning.png'>" : null;
					
					//Если запись заблокирована, ее кто-то начал реактировть...
					#if ($lockInfo=t3lib_BEfunc::isRecordLocked($ar[$i]['table'], $ar[$i]['damp']['uid'])):
						#$aOnClick = 'alert('.$GLOBALS['LANG']->JScharCode($lockInfo['msg']).');return false;';
						//$content .= '<a href="#" onclick="'.htmlspecialchars($aOnClick).'">'.
					#	$iconLock = t3lib_iconWorks::getSpriteIcon('status-warning-in-use',array('title'=>htmlspecialchars($lockInfo['msg']))).
						//'</a>';
					#endif;
	
					// вывод id-элемента
					$content .= "<span class='dop-information'>";
					$content .= "&nbsp; <input type='button' value='№ ".$row['damp']['uid']."' class='idElement' style='margin-top: -2px;'> ";
					$content .= "</span>";
					
					// вывод crdate-элемента (crdate или starttime)
					if ( $row['damp']['starttime'] > 0 ){
						$content .= "<span class='dop-information'>";
						$content .= "&nbsp; <input type='button' value='". date('d.m.Y H:i:s', $row['damp']['starttime']) ."' class='crDate' style='margin-top: -2px;'> ";
						$content .= "</span>";
					} else {
						if ( $row['damp']['crdate'] > 0 ){
							$content .= "<span class='dop-information'>";
							$content .= "&nbsp; <input type='button' value='". date('d.m.Y H:i:s', $row['damp']['crdate']) ."' class='crDate' style='margin-top: -2px;'> ";
							$content .= "</span>";
						}
					}
					
					// для зеленых веточек выводим уровень вложенности
					if ( $row['levelOnlyGreenTree'] > 0 ){
					$content .= "<span class='dop-information'>";
					$content .= "&nbsp; <input type='button' value='уровень: ".$row['levelOnlyGreenTree']."' class='levelOnlyGreenTree' style='margin-top: -2px;'> ";
					$content .= "</span>";
					}
					
					// вывод иконки языка (для переводов)
					if ($GLOBALS['BE_USER']->uc['tx_board_bonding_flag_show_translate'] == 1) {
						if ($row['table'] == "pages") {
							$content .= "&nbsp; <img src='".t3lib_extMgm::extRelPath('boards')."res/lang-default.png' 
							style='vertical-align: middle; margin-top: -1px;'>";
							
						} elseif (!empty($GLOBALS['TCA'][$row['table']]['ctrl']['transForeignTable'])
						 || !empty($GLOBALS['TCA'][$row['table']]['ctrl']['languageField'])) {
							if (isset($row['damp']['sys_language_uid'])) {
								if ($row['damp']['sys_language_uid'] == -1) {
									$content .= "&nbsp; <img src='".t3lib_extMgm::extRelPath('boards')."res/lang-multi.png' 
									style='vertical-align: middle; margin-top: -1px;'>";
								} elseif ( $row['damp']['sys_language_uid'] == 0 ) {
									$content .= "&nbsp; <img src='".t3lib_extMgm::extRelPath('boards')."res/lang-default.png' 
									style='vertical-align: middle; margin-top: -1px;'>";
								} elseif ($row['damp']['sys_language_uid'] > 0) {
									$sysLangId = $row['damp']['sys_language_uid'];
									$icon = $this->sys_language_records[$sysLangId];
									$content .= "&nbsp; <img src='/typo3/sysext/t3skin/images/flags/".$icon.".png' style='vertical-align: middle; margin-top: -1px;'>";
									// $this->sys_language_codes;
								} else {
									// skip
								}
							}
						} else {
							// skip
						}
					}
					
					$content .= "&nbsp;".$row['title'] .$this_is_new;
					
					// Вывод картинки превью
					#$picThumbNail = t3lib_BEfunc::getThumbNail('/typo3/thumbs.php', 'fileadmin/template/img/logo.jpg', " style='border: white 1px solid; max-width: 72px;' ", 30);
					#$content .= $picThumbNail; 
					#$content .= " 
					#	<img src='/typo3temp/_processed_/preview_Tulips_ad68cb656d.jpg' height='14' style='border: gray 1px slid; opacity: 0.5;'>
					#	<img src='/typo3temp/_processed_/preview_Tulips_ad68cb656d.jpg' height='14' style='border: gray 1px slid; opacity: 0.5'>
					#	<img src='/typo3temp/_processed_/preview_Tulips_ad68cb656d.jpg' height='14' style='border: gray 1px slid; opacity: 0.5'> 
					#";
					
					$content .= ' [<b style="color: '.$csscolor.';" class="bCountElements">'.(($row['toooltip_info']['countelements'] == null) ? 0 : $row['toooltip_info']['countelements']). "</b>] " . $commentary . "</span>";
					//$content .= "&nbsp;".$row['title'] . ' ['.$row['id'].'|'.$row['pid'].'|'.$level.'<b style="color: '.$csscolor.';">'.$row['toooltip_info']['countelements']. "</b>]";
					$content .= $tooltip."</span>";
					
					// Языки (справка) || Права доступа
					$content .= "<div style='position: absolute; right: 0; padding-right: 5px; line-height: 26px;'>
					<span class='dop-information'>";
					
						// Проверяем, если есть возможность переводить запись?
									
								// Обычно это - "pages_language_overlay"
							if (!empty($GLOBALS['TCA'][$row['table']]['ctrl']['transForeignTable']) && $row['table'] == "pages"){ // сделал только для данной таблицы :)
								if (isset($GLOBALS['TCA'][$row['table']]['ctrl']['transForeignTable'])){
									$content .= "&nbsp; <img 
									src='".t3lib_extMgm::extRelPath('boards') ."res/translate.png'
									style='vertical-align: middle; margin-top: -1px;'>&nbsp;";
								}
								// Assemble language condition only if a language field is defined
							} elseif (!empty($GLOBALS['TCA'][$row['table']]['ctrl']['languageField'])) {
								if(isset($GLOBALS['TCA'][$row['table']]['ctrl']['transOrigPointerField'])){	
									$content .= "&nbsp; <img 
									src='".t3lib_extMgm::extRelPath('boards') ."res/translate.png'
									style='vertical-align: middle; margin-top: -1px;'>&nbsp;";
								}
							} else {
								 // пропускаем если ни тот, 
								 // ни другой вариант локализации
							}
							
							
						// Зафиксировать доску (beta)
						$content .= "<img 
						src='".t3lib_extMgm::extRelPath('boards') ."res/fix.png' onclick='alert(\"Beta :: зафиксировать ветку\"); return false;'> &nbsp; ";
					
					
					//$content .= "<img src='".t3lib_extMgm::extRelPath('boards') ."res/world-edit.png'>";
					$content .= $row['toooltip_info']['user_access']; // права доступа
					$content .= "</span></div>"; 					
					$content .= "</a>";
				
				}
				//Если это элементы, помещенные в папочку...
				elseif ($row['typeElem'] == "folder")
				{
					// Оберкта для титле
					$row['title'] = " <span class='label'>".$row['title']."</span>";
					$csscolor = ( $row['toooltip_info']['countelements'] >= 1 ) ? 'black' : 'gray'; 
					//$content .= "<input disabled value='".$row['toooltip_info']['PANELMODERATION_value']."'>";
					$content .=  '<li><div class="allpanelelement folder" style="border-left: black 3px solid;" idBoard="'.$boardUid.'" pattern="'.$row['toooltip_info']['UNICALE_key_generation'].'" ';
					$content .=  'isOpen="'. (($this->searchUNICALE_key( $row['toooltip_info']['UNICALE_key_generation'] ) == 1)? 'yes':'no')  .'">';
					//$content .= "<input class='panelmoderation_element_value' disabled value='".$row['toooltip_info']['PANELMODERATION_value']."'>";
					$content .= "<a href='{$linkdocument}' class='ajaxloadbranch'>"; //ссылка на октрыть, закрыть
					$content .= "<span class='wrapcontentprimary'><span class='".$cssClass_noActiveTreeBranch."'>{$simbol}&nbsp;"; // cssClass_noActiveTreeBranch - если ветка далее идет не активной из-за вкл.,выкл., удаленности в корзину родительского элемента...
					$content .= $add . " ";
					$content .= t3lib_iconWorks::getSpriteIcon('status-status-reference-soft',array('fortooptipkey' => 'tooptip_'.$row['toooltip_info']['UNICALE_key_generation'], 'class' => 'c-recIcon'));
					$content .= "&nbsp;".$row['title'] . ' [<b style="color: '.$csscolor.';">'.$row['toooltip_info']['countelements']. "</b>]</span>";
					$content .= $tooltip."</span></a>";
				}
				//Если это элементы, помещенные в папочку по лимитам записи......
				elseif ($row['typeElem'] == "limit_record")
				{
					// Оберкта для титле
					$row['title'] = " <span class='label'>".$row['title']."</span>";
					$csscolor = ( $row['toooltip_info']['countelements'] >= 1 ) ? 'black' : 'gray'; 
					$content .=  '<li><div class="allpanelelement limit_record" style="border-left: black 3px solid;" idBoard="'.$boardUid.'" pattern="'.$row['toooltip_info']['UNICALE_key_generation'].'" ';
					$content .=  'isOpen="'. (($this->searchUNICALE_key( $row['toooltip_info']['UNICALE_key_generation'] ) == 1)? 'yes':'no')  .'">';
					//$content .= "<input class='panelmoderation_element_value' disabled value='".$row['toooltip_info']['PANELMODERATION_value']."'>";
					$content .= "<a href='{$linkdocument}' class='ajaxloadbranch'>"; //ссылка на октрыть, закрыть
					$content .= "<span class='wrapcontentprimary'><span class='".$cssClass_noActiveTreeBranch."'>{$simbol}&nbsp;"; // cssClass_noActiveTreeBranch - если ветка далее идет не активной из-за вкл.,выкл., удаленности в корзину родительского элемента...
					$content .= $add . " ";
					$content .= t3lib_iconWorks::getSpriteIcon('actions-view-go-down',array('fortooptipkey' => 'tooptip_'.$row['toooltip_info']['UNICALE_key_generation'], 'class' => 'c-recIcon'));
					$content .= "&nbsp;".$row['title'] . '</span>';
					$content .= $tooltip."</span></a>";
				}
				//Если данные не найдены
				elseif ($row['typeElem'] == "result_null")
				{
					// Оберкта для титле
					$row['title'] = " <span class='label'>".$row['title']."</span>";
					$content .=  '<li><div class="allpanelelement result_null" style="border-left: black 3px solid;" idBoard="'.$boardUid.'" pattern="'.$row['toooltip_info']['UNICALE_key_generation'].'" ';
					$content .=  'isOpen="'. (($this->searchUNICALE_key( $row['toooltip_info']['UNICALE_key_generation'] ) == 1)? 'yes':'no')  .'">';
					$content .= "<input class='panelmoderation_element_value' disabled type='hidden' value='".$row['toooltip_info']['PANELMODERATION_value']."'>";
					$content .= "<span class='wrapcontentprimary'><span class='".$cssClass_noActiveTreeBranch."'>{$simbol}&nbsp;"; // cssClass_noActiveTreeBranch - если ветка далее идет не активной из-за вкл.,выкл., удаленности в корзину родительского элемента...
					$content .= $add . " ";
					$content .= t3lib_iconWorks::getSpriteIcon('apps-pagetree-page-no-icon-found',array('fortooptipkey' => 'tooptip_'.$row['toooltip_info']['UNICALE_key_generation'], 'class' => 'c-recIcon'));
					$content .= "&nbsp;<span style='color: red;'>".$row['title']."</span></span>";
					$content .= $tooltip."</span>";
					$content .= "<div style='position: absolute; right: 0; padding-right: 5px; line-height: 26px;'><span class='dop-information'>".$row['toooltip_info']['user_access']."</span></div>"; // права доступа
				}
				else
				{}
				/*	*/
				//Панель иконок...
				//if ($ar[$i]['systemElementTree'] == 1): //если это служебный элемент дерева
				/* $content .= "<span class='wrapcontentpanel'>";
				
				
				
				
					//Загружаем TCA-для данной таблицы...
					$table = $ar[$i]['table']; t3lib_div::loadTCA($table);
					$row = $ar[$i]['damp']; $rowUid = $ar[$i]['damp']['uid'];
					
					
					
					
					
					
				
					
					// "Hide/Unhide" links:
					$hiddenField = $GLOBALS['TCA'][$table]['ctrl']['enablecolumns']['disabled'];
					if ($hiddenField && $GLOBALS['TCA'][$table]['columns'][$hiddenField] && (!$GLOBALS['TCA'][$table]['columns'][$hiddenField]['exclude'] || $GLOBALS['BE_USER']->check('non_exclude_fields', $table . ':' . $hiddenField))) {
					
						if ($row[$hiddenField])	{
							$params = '&data[' . $table . '][' . $rowUid . '][' . $hiddenField . ']=0';
							$cells['hide']='<a href="#" onclick="' . htmlspecialchars("return jumpToUrl(\"" . $GLOBALS['SOBE']->doc->issueCommand($params) . "\");") . '">' .
								'<img'.t3lib_iconWorks::skinImg('../typo3conf/ext/boards/res/unhide.gif','')."title='Включить запись #{$rowUid} в таблице {$table}' border='0'>".
								'</a>';
						} else {
							$params = '&data[' . $table . '][' . $rowUid . '][' . $hiddenField . ']=1';
							$cells['hide']='<a href="#" onclick="' . htmlspecialchars("return jumpToUrl(\"" . $GLOBALS['SOBE']->doc->issueCommand($params) . "\");") . '">' .
								'<img'.t3lib_iconWorks::skinImg('../typo3conf/ext/boards/res/hidden.gif','')."title='Выключить запись #{$rowUid} в таблице {$table}' border='0'>" .
								'</a>';
						}
					}
					else
					$cells['hide'] = '<img'.t3lib_iconWorks::skinImg('../typo3conf/ext/boards/res/hidden-disabled.gif','')."title='Функция не доступна' border='0'>";
								
				
				$content .= "<table border='0' cellspacing='0' cellspacing='0'>
				<tr>
					<td>".$cells['edit'].$cells['editred'].'&nbsp;'.$cells['new']."&nbsp;&nbsp;</td>
					<td class='separatorVertical'></td>
					<td>&nbsp;&nbsp;".$cells['hide']."</td>
				</tr>
				</table>";
				
				//endif;
				
				$content .= "</span>";
				*/
				
				#print "<pre>";
			#print_r( $GLOBALS['TBE_STYLES']['spriteIconApi']['spriteIconRecordOverlayNames'] );
				#exit();
		
			
				#foreach ( $GLOBALS['TBE_STYLES']['spriteIconApi']['coreSpriteImageNames'] as $val ){
				#	print t3lib_iconWorks::getSpriteIcon($val,array('fortooptipkey' => 'tooptip_'.$row['toooltip_info']['UNICALE_key_generation'], 'class' => 'c-recIcon'));
				#	print $val . "<br />";
				#}
			
				
				//$content .= $ar[$i]['relation_color'];
				//$content .= $this->searchNextSister($tree, $i); //сестры
				$content .= "<br class='clear'></div>";
				$content .= $descrip; //подробные данные 
				//$content .= $this -> htmlTree(  $ar[$i]['tmp'], $level + 1 ); //
				
				#$tmp_tree = $tree; //удаляем данные элемент, т.к. его уже просканировали, что бы старить меньше ресурсов
				#unset($tree[$i]); //можно и не удалять (это что бы циклы по поиск PID-проходили меньше...
				
				$content .= $this->htmlTree($boardUid,$tree, $row['id'], $level + 1, $noActiveTreeBranch );
				$content .=  "</LI>";
				
				
		}
    }
 
	$content = (strlen($content) > 0) ? "<UL style='".(($level > 0)?'disp2lay:none;':null)."'>" . $content . "</UL>" : null;
	return $content;
}
	
	// Функция обрезает строку...
	function smarty_modifier_mb_truncate($string, $length = 80, $etc = '...', $charset='UTF-8')
	{
		if ($length == 0)
			return '';
	 
		if (mb_strlen($string, $charset) > $length) {
		   
		  //echo substr('abcdef', 0, 4);  // abcd
		  return trim(mb_substr($string, 0, $length, $charset)) . $etc;
		   
		} else {
			return $string;
		}
	}
	
	//Вспомогательная функция - поиск сестер в дереве ниже...
	function searchNextSister($tree,$i_nowelem){
		
			for ($i = 0; $i < count ($tree); $i++)
			{
				//Если находим сестер
				if ($tree[$i_nowelem]['pid'] == $tree[$i]['pid']
				AND $tree[$i]['include_output'] == 0 ) //исключаем текущий из поиска
				return 1;
			}
			
		return 0;
	}
	
	
	//Служебная функция - перезаписи и извлечения данных из BE-сессии о закрытых скрытых элемента
	//Возмвращяем результирующую строку с отрктыми ветками дерева
	function BEsessionEventtree () {
		
		//Извлекаем данные из сессии об открытых ветках
		#$opendocument = $GLOBALS['BE_USER']->uc['tx_board_bonding']; 
		
		#$array = file_get_contents (PATH_typo3conf . "ext/boards/temp/open-board.txt");
		#$array = unserialize ($array);
		
					#$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/test.txt", 'w+');
					#fwrite($handleConstant, print_r(  $opendocument, true)); //Запись массива (в виде строки)
					#fclose($handleConstant);	
	
			//Если у нас сущестувют события по открытию закрытию веток
			//Перебераем массив, что бы его потом переписать
		
			if (isset($GLOBALS['_GET']['treeevent'])):

				switch  ( key($GLOBALS['_GET']['treeevent']) ){
				
					//Добавляем уникальный ключ
					case 'open': 
					
						//Присоединяем значения
						$GLOBALS['BE_USER']->uc['tx_board_bonding'][ $GLOBALS['_GET']['treeevent']['open'] ] = 1;
						$GLOBALS['BE_USER']->overrideUC(); 
						$GLOBALS['BE_USER']->writeUC(); 
						return $GLOBALS['BE_USER']->uc['tx_board_bonding'];
						
						/* $array [ $GLOBALS['_GET']['treeevent']['open'] ] = 1;
						$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/open-board.txt", 'w+');
						fwrite($handleConstant, serialize($array) ); //Запись массива (в виде строки)
						fclose($handleConstant);

						
						$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/open-board-print_r.txt", 'w+');
						fwrite($handleConstant, print_r($array,true) ); //Запись массива (в виде строки)
						fclose($handleConstant);
						
						
						return $array;
						*/
						
					break;
					
					//Убираем уникальный ключ
					case 'close':
					
						//Собараем новый массив, исключаю нужный нам ключ //утичтожив - загрываем...
						$GLOBALS['BE_USER']->uc['tx_board_bonding'][ $GLOBALS['_GET']['treeevent']['close'] ] = 0;
						$GLOBALS['BE_USER']->overrideUC(); 
						$GLOBALS['BE_USER']->writeUC(); 
						return $GLOBALS['BE_USER']->uc['tx_board_bonding'];
						
						/* 
						$array [ $GLOBALS['_GET']['treeevent']['close'] ] = 0;
						$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/open-board.txt", 'w+');
						fwrite($handleConstant, serialize($array) ); //Запись массива (в виде строки)
						fclose($handleConstant);
						
						$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/open-board-print_r.txt", 'w+');
						fwrite($handleConstant, print_r($array,true) ); //Запись массива (в виде строки)
						fclose($handleConstant); */
						
						return $array;
					
					break;
					
					//Очистка сессии (стираем все открытые папки)
					case 'clear':
					
						$GLOBALS['BE_USER']->uc['tx_board_bonding'] = null;
						$GLOBALS['BE_USER']->overrideUC(); 
						$GLOBALS['BE_USER']->writeUC(); 
						return null;
						
						/* $handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/open-board.txt", 'w+');
						fwrite($handleConstant, null ); //Запись массива (в виде строки)
						fclose($handleConstant);
						
						return null; */
					
					break;
				}
	

			else:
			
				//Просто возвращяем без изменений
				//Список открытых веток
				#$GLOBALS['BE_USER']->uc['tx_board_bonding']['table_tt_infoblock_elements_news_5_1_2_2'] = 0;
				#$GLOBALS['BE_USER']->uc['tx_board_bonding']['table_tt_infoblock_elements_news_2_1_3_8'] = 0;
				//return $array;
				return $GLOBALS['BE_USER']->uc['tx_board_bonding'];
			
			endif;
	}
	
	// Вспомогательная функция (формирует доп.запрос на предмет включенности/выключенности/активности/удаленности записи
	// Необходимо для проверки дочерних элементов веточки (t3lib_BEfunc::deleteClause($val) ."<br />". t3lib_BEfunc::BEenableFields($val);)...
	// Возвращяет добавочное условие ()
	function addWhere_with_deleteClause_and_BEenableFields($table, $where){
	
		if ($where != null)
		$where .= t3lib_BEfunc::deleteClause($table) . t3lib_BEfunc::BEenableFields($table);
			
		else { 
			// Нет условий от пользователя
			$where = t3lib_BEfunc::deleteClause($table) . t3lib_BEfunc::BEenableFields($table);
			$where = preg_replace('/^AND/ism', null, trim ( $where )); // убираем в начале строки AND
			
			if ($where != null) // при условии, что что то нашли...
			$where = " WHERE " . $where;
			//$params['where'] = preg_replace("/^AND /i", null, $params['where']);
		}
		
		return $where;
	}
	
	//Вспомогательная фунция поиска ключа (функция нужна для поиска значения, что бы определить, загружать поддерево, или нет)
	//Создана для проверки открытостьи закрытости дерева
	function searchUNICALE_key ($pattern) {
	
		//table:tx_infoblock_elements_poll_question_1_0_1_;
		//print ($pattern) . "<br />";
		
		//Список все открытых элементов
		if ( $this->numopenelement[$pattern] == 1) 
		return true; //else return false;

	}
	
	//Вспомогательная функция для генерации ссывлки на открыть, закрыть документа
	function isOpenOrClose_compile_link ( $pattern  ) {
	
		//Список все открытых элементов
		$string = $this->numopenelement;
	
		//Если находим - значит создаем ссылку на закрыть, т.е если у нас эта ветка открыта
		//И тем самым отправляем сообщение на перезаписывание это значение в BE-сессию пользователя
		if ( $this->numopenelement[$pattern] == 1) 
		return "?M=web_txtestM1&id=".intval($GLOBALS['_GET']['id'])."&treeevent[close]=".$pattern;
		
		//Если не находим - значит создаем ссылку открыть
		//И тем самым отправляем сообщение на перезаписывание это значение в BE-сессию пользователя
		else
		return "?M=web_txtestM1&id=".intval($GLOBALS['_GET']['id'])."&treeevent[open]=".$pattern;
		
	}
	
	
	//Вспомогательная функция по созданию конетнта подсказки
	function createcontentDescrip ($tablename , $array, $descriprow = null){
		
		if ($descriprow == null)
		return null;
		
		$arex = explode ("," , $descriprow);
		foreach ($arex as $key => $val){
			
			$arex2 = explode (":" , $val);
			//первый - это ключ поля
			//второй - это название 
			
			$content .= "<tr><td nowrap><i>".($arex2[1])." (".((strlen($array['damp'] [ $arex2[0] ])== 0)?0:strlen($array['damp'] [ $arex2[0] ]))." символов):</i> </td>";
			if ($array['damp'] [ $arex2[0] ] == null)
			$array['damp'] [ $arex2[0] ] = "-"; //если пустой результат
			$content .= "<td>".strip_tags($array['damp'] [ $arex2[0] ] )."</td></tr>";
		}
		
			//$content = 
		
		//return $descriprow;
		
		return "<div style='background-color: #333333; color: white; padding: 5px; display: none;' class='Descripinfo'><table>
		{$content}
		</table></div>";
	
	}
	//Вспомогательная функция по созданию конетнта подсказки
	function createcontentTooltip ($array, $color, $tooltiprow = null, $lockInfo, $temp){
		
		switch ($color){
			
			//Заданные связи (не смешанные)
			case 'blue': $txt = "данные о связи содержатся в родителе"; $cssclass = "blue"; break;
			case 'gray': $txt = "данные о связи содержится в дочке"; $cssclass = "gray"; break;
			case 'green': $txt = "внутреннее построение дерева"; $cssclass = "green"; break;
				
			//смешенные
			case 'bluegreen': $txt = "смешанная связь: данные о связи содержатся в родителе + внутреннее построение дерева"; $cssclass = "multi"; break;
			case 'graygreen': $txt = "смешанная связь: данные о связи содержатся в дочке + внутреннее построение дерева"; $cssclass = "multi"; break;
				
			case 'red': $txt = "выявлены битые/утерянные/не использованные элементы"; $cssclass = "red"; break;
			default: $txt = "обычная выборка без связей"; $cssclass = null; break;
		
		}
		
		
		
			//Если от нас требуют выбор определенных полей
			if ($tooltiprow != null)
			{//НЕ БОЛЕЕ 10 полей
				$arex = explode ("," , $tooltiprow);
				for ($i = 0; $i < count ($arex); $i++)
				{
					// New 15.10.2013 удаляем пробелы
					$arex[$i] = trim($arex[$i]);
				
					if ($i >= 10) break;
					if ($array['damp'][$arex[$i]] == null) continue;
					$string[] = $arex[$i] ."=". strip_tags($array['damp'][$arex[$i]]);
				}
				$string = implode (", " , $string) . "<br />";
			}
			else {
				if ($array['damp']['uid'] > 0) //так мы отсикаем папки , лимиты и нуллевые результаты...
				$string = "uid=".$array['damp']['uid'].", pid=".$array['damp']['pid'] . "<br />";
			}
			//Если данная запись редактируется, и нам переданы данные
			if ($lockInfo != null){
				
				//{Данная запись редактируется пользователем: ".$lockInfo['username']
				$lockhtml = "Данная запись редактируется пользователем: ".$lockInfo['username'] . "<br />";
			}
		
		return "<div id='tooptip_".$array['toooltip_info']['UNICALE_key_generation']."' class='tooltip {$cssclass}' contenteditable='true'>
		
								<b>".$array['toooltip_info']['UNICALE_key_generation']."</b> [{$txt}]<br />
								{$string}
								".$array['toooltip_info']['sql_query']."<br />
								
								<!--доступные действия: способ связи-->
								
		</div>"; /*
			
								".$array['toooltip_info']['sql_validation']."<br />
								<!--{$lockhtml}
								<br />{$temp}<br />-->
		
		*/
	
	}
	
	//Вспомогательная функция, которая определяет подтип связи
	// 1 - целые числа 			uid = 9
	// 2 - числа через запятую	uid IN (1,2,5,8)
	// 3 - с префиксом таблицы  uid IN (tx_table_1, tx_table,2)
	function wheretype($tablename, $relationvalue, $damp_parent){
		
		$arex = explode (":" , $relationvalue);
		//$arex[0] - это название поля
		//$arex[1] - это подтип условия связи
		
		switch ($arex[1]){
	
			default: // 'type-1'
			//case 'type-1':
			
				if ($damp_parent['uid'] >= 0)
				return "  ".$arex[0]." = " . $damp_parent['uid'];
			
			break;
	

			case 'type-2':
				
				if ( $damp_parent[$arex[0]] != null )
				return "  uid IN ( ".$damp_parent[$arex[0]]." ) ";
			
			break;
			
			case 'type-3':
				
				if ( preg_match_all("/{$tablename}_([0-9]+)/i", $damp_parent[$arex[0]], $arr))
				return "  uid IN ( ".implode ("," , $arr[1])." ) ";
				
			break;
			
			// New (сделал для инфоблоков - там где идут выбор свойств из текущего хранилища)
			// На практике мож пригодится...
			/* case 'type-4':
			
				if ($damp_parent['uid'] >= 0)
				return "  ".$arex[0]." PID " . $damp_parent[ $arex[0] ];
			
			break; */
		
		}
		
		//Если ни какое из условий не выполняется возвращяем 0
		return null;
	}
	
	
	// для (TS-config) 
	//Вспомогательная функция, которая осуществялет сборку ts-confg-панели...
	function panelmoderatonresult(){
	
			
		
	}

}



#if (defined('TYPO3_MODE') && isset($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/boards/mod1/index.php'])) {
#	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/boards/mod1/index.php']);
#}
	//Данные класс вызывает typo3 при работе в AJAX - Режиме в localconf.php
	class tx_extkey_helloworld2_ajax{
		
		public function sayHello2($params, &$ajaxObj) {
			
			
			////////////////////////////////////////////////////////////////////////////////
			// Флаг (Настройки поведения досок) - Показывать элементы помещенные в корзину
			////////////////////////////////////////////////////////////////////////////////
			if ($GLOBALS['_GET']['xcase'] == "flag_deleted_element"):
			
				// Перезаписываем флаг (checkbox)
				$GLOBALS['BE_USER']->uc['tx_board_bonding_flag_deleted_element'] = $GLOBALS['_GET']['flag'];
				$GLOBALS['BE_USER']->overrideUC(); 
				$GLOBALS['BE_USER']->writeUC(); 
			
			////////////////////////////////////////////////////////////////////////////////
			// Флаг (Настройки поведения досок) - Показывать переводы записей
			////////////////////////////////////////////////////////////////////////////////
			elseif ($GLOBALS['_GET']['xcase'] == "flag_show_translate"):
			
				// Перезаписываем флаг (checkbox)
				$GLOBALS['BE_USER']->uc['tx_board_bonding_flag_show_translate'] = $GLOBALS['_GET']['flag'];
				$GLOBALS['BE_USER']->overrideUC(); 
				$GLOBALS['BE_USER']->writeUC(); 
			
			//Если это перезагрузка досок
			elseif ($GLOBALS['_GET']['xcase'] == "desc"):
			
				//Замеряем время работя скрипта
				//$start = microtime(true);
				
				# $handleConstant = fopen(PATH_site. "12345.txt", 'w+');
				# fwrite($handleConstant, print_r($GLOBALS['_GET'],true) ); //Запись массива (в виде строки)
				# fclose($handleConstant);
				
					$content = new tx_testtree_module1;
					$html = $content->moduleContentAjax();
				
				//Замеряем время работя скрипта
				//$time = microtime(true) - $start;
				
				//$html .= "<br /><br />" . ('Скрипт выполнялся '.round($time,3).' сек.');
				$ajaxObj->addContent('tree', $html); // . rand(1,30)
			
			//Если это создание новых записей...
			//Если это событие панели - удалить/восстановить
			elseif ($GLOBALS['_GET']['xcase'] == "panelmoderation_event_new"):
				
				//Формат данных  //tt_content|0|title
					
					/***************************************************************************************************************
						формат данных - приходящих из данных...
						//tt_infoblock_elements_uproject_country|77(исключил)|title|none|[pid] => 77    [deleted] => 0 | exampleUidRecords:N
						//@@@0.НАЗВАНИЕ ТАБЛИЦЫ | XXXX-исключил | @@@2.ПОЛЕ TITLE | @@@3.ЦВЕТ СВЯЗИ | @@@4.Значения по умолчанию | @@@5.Образец записи на основе которой посдатвлять данные "~"
						//@@@0.НАЗВАНИЕ ТАБЛИЦЫ | @@@1.Образец записи на основе которой посдатвлять данные "~" | @@@2.ПОЛЕ TITLE | @@@3.ЦВЕТ СВЯЗИ | @@@4.Значения по умолчанию |
						
						 @@@1.PID-сохранения - исключил - т.к. перенесено в значения по умолчанию
					************************************************************************************************************/
					//расшифровываем строку согласно вышеописанной модели строки
					$arex = explode ("|" , $GLOBALS['_GET']['value']);
				
					//ПЕРВЫМ ДЕЛОМ //Разбираем стандартные свойства, которые мы должны присвоить...
					preg_match_all("/\[([\w\d_:-]+)\][\s]*=>([^[]+)/i", $arex[4], $matches_vardef);
						/*****
							
							При разбитии стандартных свойств у нас получается следующий массив
							
							Array
							(
								[0] => Array
									(
										[0] => [pid] => 77    
										[1] => [deleted] => 0
									)

								[1] => Array
									(
										[0] => pid
										[1] => deleted 
										
										// New (часть 1) - 24.04.2014 (исправил БаГ) Вырезаем если находим ":type-1"
										[2] => _x_fabric_uid:type-1 - здесь может быть вот так, поэтой причине пришлось вырезать!
									)

								[2] => Array
									(
										[0] =>  77    
										[1] =>  0
									)

							)
						
					*****/
					
							
							//////////////////////////
							// New (часть 2) - 24.04.2014 (исправил БаГ) Вырезаем если находим ":type-1"
							//////////////////////////
							for ($i = 0; $i<count($matches_vardef); $i++){
								
								$temp = explode(":", $matches_vardef[1][$i]);
								if (count($temp) > 0){
									$matches_vardef[1][$i] = $temp[0];
								}
							}
					
					//ВТОРЫМ ДЕЛОМ ОПРЕДЕЛЯЕМ UID-первой записи - образца - если он существует...
					preg_match("/exampleUidRecords:([0-9]+)/i", $arex[1], $matches_example_uid_record);
					$example_damp_record = t3lib_befunc::getRecord($arex[0], $matches_example_uid_record[1], "*");
					
					//Если запись как образец найдена - мы можем произвести замену дефолтовых свойств
					if ($example_damp_record['uid'] > 0){
						
						for ($k = 0; $k < count ($matches_vardef[1]); $k++){
							
								//ключ поля //значение поля
								if (strstr($matches_vardef[2][$k] , "~")) //переобпределение поля если находии символ "~"...
								$matches_vardef[2][$k] = $example_damp_record [ $matches_vardef[1][$k]  ] ;
								
							
						}
							
						
					}
					
					
					//Лог...
					//$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/panelmoreration-log.txt", 'w+');
					//fwrite($handleConstant, print_r(  $matches_vardef, true)); //Запись массива (в виде строки)
					//fclose($handleConstant);	
				

				
				
				
				//Производим добавление записией (+ если есть "втавка во внутрь" + если есть "прикрепить к родителю"
				//Переходим к генерации данных и их вставке в зависимости от количества
				for ($i = 1; $i <= $GLOBALS['_GET']['recordsCount']; $i++){
				
					
					//Передаем в makeInstance - PID-страницы - НЕ НУЖНО!!!
					#$GLOBALS['tempPID_newrecords_insert'] = $arex[1];
						
						
						///////////////////////////////////////////////
					// ВНИМЕНИЕ - ЗЕЛЕНАЯ ДАТА (ВСТАВИТЬ ВО ВНТУРЬ)
					// А ТАКЖЕ ТИП ЗАПИСИ ДАТА (ВЫБОР ТИПА ЭЛЕМЕНТА)
					// ПРИХОДЯТ К НАМ КАК ДОБАВЛЕНИЕ К СРОКЕ ДЕФОЛТОВЫХ ПЕРЕМЕННЫХ
					// ЕСЛИ ОНИ ВЫБРАНЫ В НОВЫОЙ ЗАПИСИ
					///////////////////////////////////////////////
					
						
					$data = array();  
					
					//Вставляем все дефолтовые переменные...
					for ($j = 0; $j < count ($matches_vardef[1]); $j++)
					$data[ $arex[0] ]['NEW'][ $matches_vardef[1][$j] ] = trim( $matches_vardef[2][$j] );				
					
					#if (!isset($data[ $arex[0] ]['NEW']['pid'])) //при условии , что не существует!
					#$data[ $arex[0] ]['NEW']['pid'] = $arex[1]; //переписываем pid
					$data[ $arex[0] ]['NEW'][ $arex[2] ] = 'Новый элемент - ' . $i; //переписываем название
						
					/* $data = array();  
					$data[ $arex[0] ]['NEW'] = array(  
						'pid' => $arex[1],  
						$arex[2] => 'Новый элемент - ' . $i,
					); */  
	  
					$tce = t3lib_div::makeInstance ('t3lib_TCEmain');  
					$tce->start ($data, array());  
					$tce->process_datamap ();   
					$last_insert_id = $tce->substNEWwithIDs['NEW']; //вставленный ID-записи;
					
					//$temp.= "Последний вставленный ID.".$tce->substNEWwithIDs['NEW'] . "<br />";
					
					//собираем материал для uc - пользователя о том, какие последние элементы он добавил
					$uc_value[  $arex[0]  ][ $last_insert_id ] = true;
					
					///////////////////////////////////////////////
					// СИНИЕ СИНИЕ СИНИЕ С И Н И Е СИНИЕ СИНИЕ СИНРИЕ
					//Далее код актуален только для синих веточек
					//Если мы получичи значение закрепить в родителе
					//формат данных  [tx_infoblock_property][7] => attributes:type-2
					//название таблицы,ID, поле по которому обновить, метод префикса
					///////////////////////////////////////////////
					/*
							
							//формат массива получается такой....
							Array
							(
								[0] => [tx_infoblock_property][4] => attributes:type-2
								[1] => tx_infoblock_property
								[2] => 4
								[3] =>  attributes:type-2
							)

						
					*/
					if (trim ($GLOBALS['_GET']['updateParent']) != null){
					
						#$aaa = 3245324543;
						//matches_valupdate строку...
						#$matches_vardef = null;
						preg_match("/\[([\w]+)\]\[([0-9]+)\][\s]*=>([^[]+)/i", $GLOBALS['_GET']['updateParent'], $matches_valupdate);
						//UPDATE `introduction`.`tx_infoblock_property` SET `title` = CONCAT (`title` , 'NEW') WHERE `tx_infoblock_property`.`uid` =70;
						//добавляем данные в родителя...
						
							//ОТ CONCAT - отказываемся...
							//Т.к. с ним у меня получается лишняя запитая
						
							//Получаем поле родителя...
							$parent_table_name = trim($matches_valupdate[1]);
							$parent_record_uid = trim($matches_valupdate[2]);
							
							$arex2 = explode(":" , $matches_valupdate[3]);
							$parent_column_field = trim($arex2[0]);
							$parent_type = trim($arex2[1]);
							
							$parent_damp = t3lib_befunc::getRecord($parent_table_name, $parent_record_uid, $parent_column_field);
							
							//Если есть что обновить...
							#if ($parent_damp[$parent_column_field]){
							$newvalues = $oldvalues = $resultvalues = null; //зачищаем массивы...
							
							//Получаем текущее значение поля, которое будем обновлять
							#if ($parent_damp[$parent_column_field]){
								$oldvalues = explode("," , $parent_damp[$parent_column_field]);
								for ($p = 0; $p < count ($oldvalues); $p ++)
								if (trim($oldvalues[$p]) != null)
								$newvalues[] = $oldvalues[$p];
							#}	
								
								//добавляем новую вставленную запись...						  //(актуально только для 3-ого типа)
								$prefix = ($parent_type == "type-3") ? $arex[0] . "_" : null; //определяем префикс
								$newvalues[] = $prefix.$last_insert_id;
								$resultvalues = implode ("," , $newvalues);
								
								$queryUpdate = "UPDATE {$parent_table_name}
								SET `{$parent_column_field}` = '{$resultvalues}'  
								WHERE uid = {$parent_record_uid} LIMIT 1;";
								
								$queryUpdate_r []  = $queryUpdate;
								$GLOBALS['TYPO3_DB']->sql_query($queryUpdate); 
							#}
					
					}
					
					//Вписываем в массив BE-пользователя о последних добавленных элементах
					//Присоединяем значения
					$GLOBALS['BE_USER']->uc['tx_board_bonding_new_records_add'] = $uc_value;
					$GLOBALS['BE_USER']->overrideUC(); 
					$GLOBALS['BE_USER']->writeUC(); 
					
					#recordsUpdateParent
					#$handleConstant = fopen(PATH_typo3conf . "ext/boards/temp/panelmoreration-log.txt", 'w+');
					#fwrite($handleConstant, print_r( $queryUpdate_r , true)); //Запись массива (в виде строки)
					#fclose($handleConstant);	
				}
			//Если это событие панели - скрыть/показать
			//Если это событие панели - удалить/восстановить
			elseif ($GLOBALS['_GET']['xcase'] == "panelmoderation_event_hide" 
			OR $GLOBALS['_GET']['xcase'] == "panelmoderation_event_delete"):
				
				//Формат данных //tt_content|hidden|5,6,7,9,102,10,11,12
				//1.название таблицы 2. поле скрыватель 3. id элементов
				$arex = explode ("|" , $GLOBALS['_GET']['value']);
				
				# if ($GLOBALS['_GET']['type'] == "hide" OR $GLOBALS['_GET']['type'] == "trash") //если скрыть/удалить выбранные записи
				# $GLOBALS['TYPO3_DB']->sql_query("UPDATE ".$arex[0]." SET ".$arex[1]." = 1 WHERE uid IN (".$arex[2].") ");
				
				# if ($GLOBALS['_GET']['type'] == "unhide" OR $GLOBALS['_GET']['type'] == "retrash") //если показать/восстановить выбранные записи
				# $GLOBALS['TYPO3_DB']->sql_query("UPDATE ".$arex[0]." SET ".$arex[1]." = 0 WHERE uid IN (".$arex[2].") ");
				
					// Если это скрыть
				if ($GLOBALS['_GET']['type'] == "hide") {
					$arex2 = explode ("," , $arex[2] );
					foreach ($arex2 as $valId){
						$recData = array();  
						$recData[$arex[0]][$valId]['hidden'] = TRUE;  
	  
						$tce = t3lib_div::makeInstance ('t3lib_TCEmain');  
						$tce->start ($recData);  
						$tce->process_datamap ();  
					}
				}
					// Если это показать
				if ($GLOBALS['_GET']['type'] == "unhide") {
					$arex2 = explode ("," , $arex[2] );
					foreach ($arex2 as $valId){
						$recData = array();  
						$recData[$arex[0]][$valId]['hidden'] = FALSE;  
	  
						$tce = t3lib_div::makeInstance ('t3lib_TCEmain');  
						$tce->start ($recData);  
						$tce->process_datamap ();  
					}
				}
					// Если это удалить в корзину
				if ($GLOBALS['_GET']['type'] == "trash") {
					$arex2 = explode ("," , $arex[2] );
					foreach ($arex2 as $valId){
						$cmd = array();  
						$cmd[$arex[0]][$valId]['delete'] = 1;
	  
						$tce = t3lib_div::makeInstance ('t3lib_TCEmain');  
						$tce->start (array(), $cmd);  
						$tce->process_cmdmap ();  
					}
				}
					// Если это восстановить из корзины
				if ($GLOBALS['_GET']['type'] == "retrash") {
					$arex2 = explode ("," , $arex[2] );
					foreach ($arex2 as $valId){
						$cmd = array();  
						$cmd[$arex[0]][$valId]['undelete'] = 1;
	  
						$tce = t3lib_div::makeInstance ('t3lib_TCEmain');  
						$tce->start (array(), $cmd);  
						$tce->process_cmdmap ();  
					}
				}
				
				#$handleConstant = fopen(PATH_typo3conf . "ext/inf.txt", 'w+');
				#fwrite($handleConstant, "UPDATE ".$arex[0]." SET ".$arex[1]." = 0 WHERE uid IN (".$arex[2].") " . print_r($GLOBALS['_GET'],true)); //Запись массива (в виде строки)
				#fclose($handleConstant);	
				
				$ajaxObj->addContent('tree', null); // . rand(1,30)
				//exit(); return false;
				
			//Если это "Показать доп. информацию"
			elseif ($GLOBALS['_GET']['xcase'] == "SeeDopInfomrmation"):
			
				// Переписываем значения (логика флага)
				/* if ($GLOBALS['BE_USER']->uc['tx_board_bonding_dopInformationFlag'] == 0)
				$GLOBALS['BE_USER']->uc['tx_board_bonding_dopInformationFlag'] = 1;
				else
				$GLOBALS['BE_USER']->uc['tx_board_bonding_dopInformationFlag'] = 0;
				$GLOBALS['BE_USER']->overrideUC(); 
				$GLOBALS['BE_USER']->writeUC(); 
				*/
				
				// что-то оптавряем
				$ajaxObj->addContent('tree', $GLOBALS['BE_USER']->uc['tx_board_bonding_dopInformationFlag']); // . rand(1,30)
				
			//Если это очистка сессии "Очистить открытые элементы дерева"
			elseif ($GLOBALS['_GET']['xcase'] == "clear"):
			
				//&treeevent[clear]=1 - производится очищение
				tx_testtree_module1::BEsessionEventtree(); //т.к. существует mod.php?M=tools_txtestM1&treeevent[clear]=1
				//$ajaxObj->addContent('tree', 11); // . rand(1,30)
			
			//Если это панель администрирования
			elseif ($GLOBALS['_POST']['xcase'] == "panelmoderation"):
			
				//***********************************************************************************************************
				//ЗДЕСЬ ВВОДИТСЯ ЛОГИКА СБОРКИ ПАНЕЛИ АДМИНИСТРИРОВАНИЯ
				//***********************************************************************************************************
				/*
						//9. NEW - Если запись редактируется пользователем - мы запрещяем действия над ней и вокруг нее...
						//8. Перенес - если у нас не определен PID-пишем что создайте первую запись в ручную и при улсовии что мы кликнули на Элементы не найдены в данном раздел
						//7. NEW - проверка строки прав на управление записью... глобальная ошибка если нет доступа на редактирование проверка строки.... (access==1)
						//6. если у нас выбраны разные доски...
						//5. если у нас выбраны разные таблицы
						//4. если у наз выбраны разные pid
						//1. панель не задана
						//2. если что-то не задано
						//3. если мы ничего не отметили из элементов (будет доступно только создать)
				*/
				//***********************************************************************************************************
				//***********************************************************************************************************
				
				// 9. ОШИБКА: данная запись сейчас редактируется (попробуйте позже)...
				preg_match_all("/uid:([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_example_uid);
						
				// 8. ОШИБКА: не определен pid - необходимо первую запись создавать в ручную
				preg_match_all("/\[([pid]+)\][\s]*=>[\s]*([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_vardefpid);
				
				//7. ОШИБКА: проверка строки прав на управление записью...
				preg_match_all("/access_string:([\w]+)/", $GLOBALS['_POST']['panelmoderationvalue'], $matches_access_string);
				
				//6. ОШИБКА: если у нас выбраны разные доски...
				preg_match_all("/board:([0-9]+)/", $GLOBALS['_POST']['panelmoderationvalue'], $matches_board);
				for ($i = 0; $i < count ($matches_board[1]); $i++)
				$tempvalid_board[ $matches_board[1][$i] ] = true;
				
				//5. ОШИБКА: если у нас выбраны разные таблицы
				preg_match_all("/table:([\w]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_table);
				for ($i = 0; $i < count ($matches_table[1]); $i++)
				$tempvalid_table[ $matches_table[1][$i] ] = true;
				
				//4. ОШИБКА: если у выбраны наз разные pid
				preg_match_all("/pid:([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_pid);
				for ($i = 0; $i < count ($matches_pid[1]); $i++)
				$tempvalid_pid[ $matches_pid[1][$i] ] = true;
				
				//1. ОШИБКА: панель не задана
				preg_match_all("/panel:([*]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_panel);
				for ($i = 0; $i < count ($matches_panel[1]); $i++)
				$tempvalid_panel[ $matches_panel[1][$i] ] = true;
				
				//Если запись заблокирована, ее кто-то начал реактировть - стоп...
				if ($lockInfo = t3lib_BEfunc::isRecordLocked($matches_table[1][0], $matches_example_uid[1][0])){
					
					$ajaxObj->addContent('tree', '
				
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>
									<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_error.png">
										<div><b>Запись уже редактируется!</b></div>
										
										<br /><i>Выбранная Вами запись уже редактируется пользователем
										<span style="font-weight: bold;">'.$lockInfo['username'] .' </span> от '.date("Y-m-d H:i:s" , $lockInfo['tstamp']).'. <br />
										<br />Настоятельно не рекомендуем производить над ней какие-либо действия в других модулях.
										<!--<br /> Свяжитесь с данным пользователем, либо попробуйте обратиться к данной записи немного позже.-->
										
										<br /><br />
										Щелчок - свернет панель...
										</i>
										
										
										</div>
									</td>
								</tr>
					</table>');
					
				}
				#6->
				elseif(count($tempvalid_board) > 1){ //если выбраны две разные доски - стоп
				
					$ajaxObj->addContent('tree', '
				
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>
									<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_error.png">
										<div><b>Сообщение системы!</b></div>
										
										<br /><i>Для работы с данными выбраны разные доски!<br />
										Снимите отметки с одной из досок и выбирете элементы только на одной доске. <br /><br />
										Совет: держите отрытой только ту доску, <br /> которую собираетесь редактировать!
										
										<br /><br />
										Щелчок - свернет панель...
										</i>
										
										</div>
										
									</td>
								</tr>
					</table>');
					
				}
				#5->
				elseif (count($tempvalid_table) > 1){ //если выбраны две разные таблицы стоп...
				
					$ajaxObj->addContent('tree', '
				
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>
									<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_error.png">
										<div><b>Сообщение системы!</b></div>
										
										<br /><i>Выбраны данных из разных таблиц!<br />
										Редаткирование не возможно - необходимо выбрать записи схожих типов на одной доске. <br /><br />
										Совет: разнотипность данных Вы можете определить по цветам бюрдюров, расположенных слевой стороны!
										
										<br /><br />
										Щелчок - свернет панель...
										</i>
										
										</div>
										
									</td>
								</tr>
					</table>');
						
				} 
				#1->panel
				elseif (strstr($GLOBALS['_POST']['panelmoderationvalue'], "panelModerationIsUndefined")) { // если панель управления не задана - стоп
				//elseif (preg_match_all('/(panelModerationIsUndefined)$/i', trim($GLOBALS['_POST']['panelmoderationvalue']), $matches)){
				
					$ajaxObj->addContent('tree', '
				
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>
									<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/stop.png">
										<div><b>Сообщение системы!</b></div>
										
										<br /><i>[Панель управления данными не задана]!<br /></i>
										
										</div>
										
									</td>
								</tr>
					</table>');
					
				}
				#8->panel
				elseif ( $matches_vardefpid[2][0] == null){ // OR trim($matches_vardefpid[2][0]) == "~" //Если у нас не указан пид - проси в ручную создать стартувую запись..
					
					$ajaxObj->addContent('tree', '
				
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>
									<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/comment_settings.png">
										<div><b>Сообщение системы!</b></div>
										
										<br /><i>
										Управление записью не возможно - не удалось определить хранилище. 
										Для создания новой записи перейдите в модуль вэб-списоков и в ручною создайте
										первую-стартовую запись необходимого типа!
										
										<br /><br />
										Щелчок - свернет панель...
										</i>
										
										
										</div>
										
									</td>
								</tr>
					</table>');
					
				}
				#7->
				// Если не находим право изменение, либо право на хранилище, либо право на тип содержимого (пока для pages, tt_content - выходим)
				elseif (!strstr($matches_access_string[1][0],"W")  // если нет права на редактирование
					 OR !strstr($matches_access_string[1][0],"S")) // если нет прав на хранилище
				{
 				
					$ajaxObj->addContent('tree', '
				
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>
									<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/lock.png">
										<div><b>Нет доступа!</b></div>
										
										<br /><i>Доступ на управление данной записью не определен для Вашего пользователя! <br /><br />
										Возможные причины - 1) нет возможности редактировать записи данной таблицы - <span class="all_accesss_type w not"><s>W</s></span>, 
										2) нет доступа к хранилищу, где содержиться запись - <span class="all_accesss_type s not"><s>S</s></span>, 
										3) (beta) нет доступа к типу записи (для pages, tt_content) - beta<br /></i>
										
										<br />Если Вы считаете что должны иметь права на управление данной записью - обратитесь к администратору проекта.
										
										<br /><br />
										<div align="center">Текущя строка доступных прав: <span class="all_accesss_type">
										'.(($matches_access_string[1][0] == null) ? "не определена" : $matches_access_string[1][0]).'</span></div>
										</div>
									</td>
								</tr>
					</table>');
					
				}
				else {
					
					if (count($tempvalid_pid) > 1){ //если выбраны разные pid...
					
						$option_edit_columnts = "<option disabled>Выбор полей не возможен</option>
						<option disabled>т.к. выбраны разные хранилища</option>";
						
						//Доступно только 1-поле fieldname 
						//preg_match_all("/panel-fieldname:([^|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_fieldname);
						//if ( $matches_fieldname[1][0] )
 						//$option_edit_columnts .= "<option disabled>Выбор полей не возможен</option>
						//<option disabled>т.к. выбраны разные хранилища</option>";
						
						//option_edit_columnts
						
						//Блокируем - т.к. выбраны разные хранилища...
						//$eventEditDisabled = 1;
						
					} else {
					
						//Передаем id-страницы...
						$pageid = key($tempvalid_pid);
						t3lib_div::loadTCA( key($tempvalid_table) ); //загружаем TCA-на всякий случай!
						
						//Производим компиляцию TCA [class.tcabild.php]
						// Не актуально без платформы $obj = t3lib_div::makeInstance("tx_infoblock_user_tcamanipulate_dynamic_compiler");
						// Не актуально без платформы $obj->tableTCAcompiler_main ( $pageid );
						
						//Выбираем колонки только необходимой TCA
						$all_columnts_to_table = $GLOBALS['TCA'][ key($tempvalid_table) ]['columns'];
						$option_edit_columnts = null;
						
						foreach ($all_columnts_to_table as $key => $value){
							
							$label = $GLOBALS['LANG']->sL($value['label'], true);
							//$label = substr($label, 0, 25);
										
							if (strlen ($label) > 0) {
								$label = $label. " [".$key."]";
								$option_edit_columnts .= "<option value=".$key.">".$label."</option>";
							}
						}
						#$tempvalid_pid
					}
					
						//Создаем поле выбора типа данных:
						#$option_edit_columnts = "<option disabled>Выбор полей не возможен</option>
						#<option disabled>т.к. выбраны разные хранилища</option>";
						
						//Выбираем колонки только необходимой TCA
						$type_table = $GLOBALS['TCA'][ key($tempvalid_table) ]['ctrl']['type'];
						$option_select_type = null;
						$all_type_to_table = $GLOBALS['TCA'][ key($tempvalid_table) ]['columns'][$type_table]["config"]["items"];
						$all_type_to_table_defult_selected = $GLOBALS['TCA'][ key($tempvalid_table) ]['columns'][$type_table]["config"]['default'];
						
						foreach ($all_type_to_table as $key => $value){
							
							if (strstr($value[1], "--"))
							continue;
							
							$label = $GLOBALS['LANG']->sL($value[0], true);
							//$label = substr($label, 0, 25);
										
							if (strlen ($label) > 0) {
								$label = $label. " [".$value[1]."]";
								
								#$resultkey = " = " . $value[1];
								$option_select_type .= "<option 
								".(($value[1] == $all_type_to_table_defult_selected) ? "selected": "")."
								style='background: #fff url(".$value[2].") 2px 2px no-repeat; height: 20px; padding-left: 22px;'
								value='[".$type_table."] => ".$value[1]."'>".$label."</option>";
							}
						}
						
						//Если пусто...
						if ($option_select_type == null)
						$option_select_type .= "<option value='0'>[По умолчанию]</option>";
					
					//Определяем цвет веточек - если это НЕ зеленые - блокируем кнопку вставки во внутрь...
					/* preg_match_all("/relation_color:([a-z]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_rcolor); //получаем материал для вставки во внтурь - актуально только для зеленых веточек
					preg_match_all("/panel-material-if-insert-into:([^|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_if_insert_into); //выявляем всю панель
					preg_match_all("/panel-material-if-ifupdate-parent:([^|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_if_update_parent); //выявляем всю панель
					if (strstr($matches_rcolor[1][0], "green")) $input_into_insert = "<input id='tx_infoblock_panel_moderation_new_insert_into_flag' type='checkbox' disabled> вставить во внутрь <input id='tx_infoblock_panel_moderation_new_insert_into' value='".$matches_if_insert_into[1][0]."' type='hidden'><br /><br />";
					if (strstr($matches_rcolor[1][0], "blue")) $input_update_parent = "<input id='tx_infoblock_panel_moderation_new_update_parent_flag' type='checkbox' disabled checked> закрепить в родителе <input id='tx_infoblock_panel_moderation_new_update_parent' value='".$matches_if_update_parent[1][0]."' type='hidden'><br /><br />";
					if ($matches_rcolor[1][0] == null) $matches_rcolor[1][0] = "none"; //если цвета нет...
					*/
					
					//NEW. >> Создаем ссылку на новый элемент
					// Create Links Create new "Content Element" 
					preg_match_all("/panel-fieldname:([^|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_fieldname);
					preg_match_all("/panel-newdefvar:Array\([\s]*(.+)\):panel-newdefvar-end/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_vardef); //выявляем всю панель
					preg_match_all("/\[([pid]+)\][\s]*=>[\s]*([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_vardefpid);
					preg_match_all("/uid:([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_example_uid);
						
							//preg_match_all("/\[([pid]+)\][\s]*=>([^[^)]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_vardefpid); //определяем pid-в который будем писать нов.запись
							//preg_match_all("/pid:([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_vardefpid); //определяем pid-в который будем писать нов.запись
					
					//Определяем цвет веточек - если это НЕ зеленые - блокируем кнопку вставки во внутрь...
					preg_match_all("/relation_color:([a-z]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_rcolor); //получаем материал для вставки во внтурь - актуально только для зеленых веточек
					preg_match_all("/panel-material-if-insert-into:([^|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_if_insert_into); //выявляем всю панель
					preg_match_all("/panel-material-if-ifupdate-parent:([^|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_if_update_parent); //выявляем всю панель
					if (strstr($matches_rcolor[1][0], "green") AND trim($matches_example_uid[1][0]) > 0) {
							// Проверяем если запрещена вставка в данных 
						$input_into_insert = "<input id='tx_infoblock_panel_moderation_new_insert_into_flag' type='checkbox' disabled> вставить во внутрь <input id='tx_infoblock_panel_moderation_new_insert_into' value='".$matches_if_insert_into[1][0]."' type='hidden'><br /><br />";
						
						$rowTelem = t3lib_befunc::getRecord($matches_table[1][0], $matches_example_uid[1][0], "uid,telem,pelem");
						foreach ($GLOBALS['TCA'][$matches_table[1][0]]['columns']['telem']['config']['items'] as $_k => $_v){
							if ($_v[1] == $rowTelem['telem'] && $_v[3] == "-"){ // запрет children
								$input_into_insert = "";
								break;
							}
						}
					}
					if (strstr($matches_rcolor[1][0], "blue")) $input_update_parent = "<input id='tx_infoblock_panel_moderation_new_update_parent_flag' type='checkbox' disabled checked> закрепить в родителе <input id='tx_infoblock_panel_moderation_new_update_parent' value='".$matches_if_update_parent[1][0]."' type='hidden'><br /><br />";
					if ($matches_rcolor[1][0] == null) $matches_rcolor[1][0] = "none"; //если цвета нет...					
					
					#оСТАНОВИЛСЯ ЗДЕСЬ					
					#preg_match_all("/panel-newdefvar:Array\([\s]*(.+)\):panel-newdefvar-end/i", "panel-newdefvar:Array(    [pid] => 77    [deleted] => 0):panel-newdefvar-end", $matches_vardef);
					#preg_match_all("/\[([\w\d_]+)\][\s]*=>([^[]+)/i", $matches_vardef[1][0], $matches_vardef2);
					
					#$temp_vardef = unserialize ($matches_vardef[1][0]); //расшифровываем строку
					//tt_infoblock_elements_uproject_country|77|title|none|[pid] => 77    [deleted] => 0
					//изменил на 
					//tt_infoblock_elements_uproject_country|title|none|[pid] => 77    [deleted] => 0
					//изменил на 
					//tt_infoblock_elements_uproject_country|title|none|[pid] => 77    [deleted] => 0 | exampleUidRecords
					
					//$matches_varpid = $matches_vardefpid[1][0]; //вставляем id-хранилищая, в которое надо вставить...
					//$params = key($tempvalid_table).'|'.trim($matches_varpid).'|' . $matches_fieldname[1][0] . "|" . $matches_rcolor[1][0] . "|" . $matches_vardef[1][0]; //определяем поле которому вставляется название
					$params = key($tempvalid_table).'|exampleUidRecords:'.trim($matches_example_uid[1][0]).'|' . $matches_fieldname[1][0] . "|" . $matches_rcolor[1][0] . "|" . $matches_vardef[1][0]; //определяем поле которому вставляется название
					$cells['new_tpl'] = $params; //@@@НАЗВАНИЕ ТАБЛИЦЫ | @@@PID-сохранения | @@@ПОЛЕ TITLE | @@@ЦВЕТ СВЯЗИ | @@@Значения по умолчанию
						
					//EDIT. >> Создаем ссылку на редактирование
					// Edit only "title" and "hidden" fields from record:
					//получаем список всех выбранных ID
					preg_match_all("/uid:([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_uid_element);
					$params = 'edit['.key($tempvalid_table).']['.implode("," , $matches_uid_element[1]).']=edit'; //&columnsOnly=
					$cells['edit_tpl'] = htmlspecialchars("alt_doc.php?returnUrl=".urlencode("mod.php?M=web_txtestM1&id=".intval($GLOBALS['_POST']['id']))."&{$params}");
					
					//Hide. >> Создаем ссылку на скрыть/показать
					// "Hide/Unhide" links:
					$hiddenField = $GLOBALS['TCA'][ key($tempvalid_table) ]['ctrl']['enablecolumns']['disabled'];
					$params = key($tempvalid_table).'|'.$hiddenField.'|'.implode("," , $matches_uid_element[1]);
					$cells['hide_tpl'] = $params;
					
					//Trash. >> Создаем ссылку на удалить/восстановить
					// "Trash/Retrash" links:
					$deleteField = $GLOBALS['TCA'][ key($tempvalid_table) ]['ctrl']['delete'];
					$params = key($tempvalid_table).'|'.$deleteField.'|'.implode("," , $matches_uid_element[1]);
					$cells['trash_tpl'] = $params;
					
					//Определяем ID-доски
					preg_match("/board:([0-9]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_uid_board);
							
					//Определяем панель администрирования
					#preg_match("/tsconf-panel:([\W]?+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $tsconf_panel);
					
					//Получаем заблокированные поля (события)
					preg_match_all("/panel-eventdisabled:([a-z|]+)/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_eventdisabled);
					#$matches_eventdisabled[1][0];
					
					//Если у нас существет диалог
					preg_match_all("/panel-dialog:(.+);/i", $GLOBALS['_POST']['panelmoderationvalue'], $matches_dialog);
					if (trim($matches_dialog[1][0]) != null){
						
						//
						$dialog_content = '<div class="dialogclickhide" style="position: absolute; width: 100%; height: 500px; z-index: 100000;">
							
										<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
										<tr>
										<td>
									
										<div class="panel_moderation_box dialog" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/dialog.png">
										<div><b>Обратите внимание!</b></div>
										
										<br /><i>['.$matches_dialog[1][0].']!<br /></i>
										
										<!--<br /><input type="button" value="-= продолжить =-">-->
										
										</div>
										
										</td>
										</tr>
										</table></table>
							
							
						</div>';
							
					}
					
					
					// В качестве справки пищем - с каким хранилищем работаем - для "Хранилище куда будет сохранено"
					$temp_data_page = t3lib_befunc::getRecord("pages", $matches_vardefpid[2][0], "*");
					$temp_icon_page = ($temp_data_page['uid'] > 0) ?t3lib_iconWorks::getSpriteIconForRecord('pages', $temp_data_page) : null; // иконка
					
					$temp = print_r( $matches_vardefpid, true);
					$content = $dialog_content.'
					
							<div id="panel_label" style="background: white; color: gray;">
							Панель управления элементом(ами) в хранилище '.$temp_icon_page.' '.$temp_data_page['title'].' ['.$matches_vardefpid[2][0].']</div>
					
							<textarea style="display: none; width: 700px; height: 200px; position: absolute;">'.$temp.'</textarea>
							<!--ID-доски (скрытое поле)-->
							<input id="panelModeration_value_TO_event_BoardUid" type="hidden" style="position: absolute;" value="'.$matches_uid_board[1].'">
							
								<table cellpadding="5" cellspacing="15" style="border: red 0px solid; padding-top: 25px;" align="center">
								<tr>';
								
									$ieventdisplay = 0;
									if ( strstr($matches_eventdisabled[1][0], "new") ): 1; else: //если не заблокировано
									
										$content .= '
										<td>
										<div class="panel_moderation_box"><input type="radio" class="radioabsolut" name="panel_moderation_event" value="new">
										<div class="check-icon-duble">'.t3lib_iconWorks::getSpriteIcon("actions-document-new").'</div>
										<img class="info-graphics" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_new.png">
										<div><b>Новая запись</b></div>
										
										<select id="tx_infoblock_panel_moderation_new_type"  style="width: 100%;" disabled="true">
											'.$option_select_type.'
										</select>
										<select id="tx_infoblock_panel_moderation_new_count" style="width: 100%;" disabled>
											<option value="1">1 новая запись</option>
											<option value="2">2 новых записи</option>
											<option value="3">3 новых записи</option>
											<option value="5">5 новых записей</option>
											<option value="10">10 новых записей</option>
											<option value="25">25 новых записей</option>
											<!--<option value="50" style="background-color: red; color: white;">50 новых - так много за 1 раз?</option>-->
										</select><br />
										<br />'.$input_into_insert.$input_update_parent.'
										
										
										<i>Создание новых записей с указанием их типа, а также количества</i>
										<input id="panelModeration_value_TO_event_new_data" type="hidden" value="'.$cells['new_tpl'].'">
										</div>
										
										<!--<br /><br /><br />-->
										
										'; $ieventdisplay ++;
									
										$content .= '
										</td>'; 
									
									endif;
									
									if ( strstr($matches_eventdisabled[1][0], "edit") ): 1; else: //если не заблокировано
									$content .= '
										<td>
										<div class="panel_moderation_box"><input type="radio" class="radioabsolut" name="panel_moderation_event" value="edit">
										<div class="check-icon-duble">'.t3lib_iconWorks::getSpriteIcon("actions-document-open").'</div>
										<img class="info-graphics" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_edit.png">
										<div><b>Редактировать</b></div>
										
										
										<select id="panelModeration_value_TO_event_edit_data_columnsOnly" multiple="true" size="9" style="width: 100%;" disabled>
											<option disabled>-- Все доступные поля (по умолчанию) --</option>
											'.$option_edit_columnts.'
										</select><br />
										<!--<br /><input type="checkbox" disabled> без вкладок<br />-->										
										<br /><i>Переход к редактированию выбранных записей с набором указанных полей</i>
										<input id="panelModeration_value_TO_event_edit_data" type="hidden" value="'.$cells['edit_tpl'].'">
										</div>'; $ieventdisplay ++;
									
									$content .= '
									</td>'; endif;
									
									$openTdHidden = 0;
									$openTdDelete = 0;
									
									//[ctrl][enablecolumns][disabled]
									if ( strstr($matches_eventdisabled[1][0], "hidden") ) 1; //если не заблокировано
									elseif ($GLOBALS['TCA'][ key($tempvalid_table) ]['ctrl']['enablecolumns']['disabled'] == false){
										$content .= '
										<td>
										<div class="panel_moderation_box" style="padding-top: 48px !important;">
										<div class="check-icon-duble">'.t3lib_iconWorks::getSpriteIcon("actions-edit-delete").'</div>
										<img class="info-graphics-small" id="tx_infoblock_panel_moderation_deleted_graphics" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_hide.png" height="90">
										<div><b>Активность</b></div>
										Функция не определена для элементов данной таблицы.</div>
										'; $ieventdisplay ++;
										$openTdHidden = 1;
									}
									#if (!strstr($GLOBALS['_POST']['panelmoderationvalue'], "@hidden")):
									else {
										$content .= '
										<td>
										<div class="panel_moderation_box" style="padding-top: 48px !important;"><input type="radio" class="radioabsolut" name="panel_moderation_event" value="hide">
										<div class="check-icon-duble">'.t3lib_iconWorks::getSpriteIcon("actions-edit-hide").'</div>
										<img class="info-graphics-small" id="tx_infoblock_panel_moderation_hidden_graphics" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_hide.png" height="90">
										<div><b>Активность</b></div>
										<!--C выбранными: <br />-->
										<input type="radio" id="tx_infoblock_panel_moderation_hidden_1" name="tx_infoblock[panel_moderation][hidden]" value="1" disabled><label for="tx_infoblock_panel_moderation_hidden_1"> Включить</label> / 
										<input type="radio" id="tx_infoblock_panel_moderation_hidden_0" name="tx_infoblock[panel_moderation][hidden]" value="0" disabled checked><label for="tx_infoblock_panel_moderation_hidden_0"> выключить</label>
										
										<!--
											<br /> <br />
											<i>Позволяет скрыть записи без перемещения их в корзину (как правильно после выключения запись не отображается на сайте)</i>
										-->
										</div>
										
										<!--Скрытое поле-->
										<input id="panelModeration_value_TO_event_hide_data" type="hidden" value="'.$cells['hide_tpl'].'">';
										
										$ieventdisplay ++;
										$openTdHidden = 1;
										$content .= ''; 
									}
									
									//[ctrl][enablecolumns][disabled]
									#if (!strstr($GLOBALS['_POST']['panelmoderationvalue'], "@delete")):
									if ( strstr($matches_eventdisabled[1][0], "delete") ) 1; //если не заблокировано
									elseif($GLOBALS['TCA'][ key($tempvalid_table) ]['ctrl']['delete'] == false){
									
										if ($openTdHidden == 0){ 
											$content .= "<td>";
										} else {
											$content .= "<br />";
										}
									
										$content .= '
										<div class="panel_moderation_box" style="padding-top: 48px !important;"><input type="radio" class="radioabsolut" name="panel_moderation_event" value="delete">
										<div class="check-icon-duble">'.t3lib_iconWorks::getSpriteIcon("actions-edit-delete").'</div>
										<img class="info-graphics-small" id="tx_infoblock_panel_moderation_deleted_graphics" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_trash.png" height="90">
										<div><b>Корзина</b></div>
										<!--C выбранными: <br />-->
										<input type="radio" id="tx_infoblock_panel_moderation_deleted_1" name="tx_infoblock[panel_moderation][deleted]" value="1" disabled checked><label for="tx_infoblock_panel_moderation_deleted_1"> только удаление</label>
										<br /><i>Для элементов данной таблицы возможно только удаление без возможности восстановления.</i>
										</div>
										
										<!--Скрытое поле-->
										<input id="panelModeration_value_TO_event_delete_data" type="hidden" value="'.$cells['trash_tpl'].'">
										';
										 $ieventdisplay ++;
										 $openTdDelete = 1;
										
									
									} else { 
									
										if ($openTdHidden == 0){ 
											$content .= "<td>";
										} else {
											$content .= "<br />";
										}
									
										$content .= '
										<div class="panel_moderation_box" style="padding-top: 48px !important;"><input type="radio" class="radioabsolut" name="panel_moderation_event" value="delete">
										<div class="check-icon-duble">'.t3lib_iconWorks::getSpriteIcon("actions-edit-delete").'</div>
										<img class="info-graphics-small" id="tx_infoblock_panel_moderation_deleted_graphics" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/panel_moderation_trash.png" height="90">
										<div><b>Корзина</b></div>
										<!--C выбранными: <br />-->
										<input type="radio" id="tx_infoblock_panel_moderation_deleted_1" name="tx_infoblock[panel_moderation][deleted]" value="1" disabled checked><label for="tx_infoblock_panel_moderation_deleted_1"> Удалить</label> / 
										<input type="radio" id="tx_infoblock_panel_moderation_deleted_0" name="tx_infoblock[panel_moderation][deleted]" value="0" disabled><label for="tx_infoblock_panel_moderation_deleted_0"> восстановить</label> 
										
										<!--
											<br /> <br />
											<i>Производит перемещение/изъятие выбранных записей в/из корзины (если функция доступна <br /> для данной таблицы)</i>
										-->
										
										</div>
										
										<!--Скрытое поле-->
										<input id="panelModeration_value_TO_event_delete_data" type="hidden" value="'.$cells['trash_tpl'].'">
										';
										 $ieventdisplay ++;
										 $openTdDelete = 1;
									
									} #endif;
									
									if ($openTdHidden == 1 OR $openTdDelete == 1) {
										$content .= '</td>';
									}
									
									//Если мы не чего не определили в событиях - пишем что панель не определена
									if ($ieventdisplay == 0)
									$content .= '
									
										<td>
										<div class="panel_moderation_box tabloclose" style="opacity: 1; width: 300px;">
										<img class="info-graphics" style="left: 100px;" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/stop.png">
										<div><b>Сообщение системы!</b></div>
										
										<br /><i>[Панель управления данными не задана]!<br /></i>
										
										</div>
										</td>
										
									';
									
									else
									$content .= '
								</tr>
								<tr>
									<td></td>
									<td></td>
									<td colspan="2" align="right">
									<div style="position: relative;">
									
										<input type="image" value="Выполнить" class="perform" disabled src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/ok_black.png" hspace="25" style="border: red 0px solid; cursor: pointer;">
										<input type="image" value="отмена" class="cancellation tabloclose" src="'.t3lib_extMgm::extRelPath('boards') .'mod1/icon/cancel.png" hspace="25" style="border: red 0px solid; cursor: pointer;">
										
									</div>
									</td>
								</tr>
								</table>
								
						</table>'; // . rand(1,30)
						
						$ajaxObj->addContent('tree', $content);
					} #end else if;
				
			//Все остальное
			else: endif;
			
		}
	}

	//Если мы что-то грузим по ajax
	/* ВСЕ ЭТО МЫ НЕ ВЫВОДИМ ЕСЛИ РАБОТАЕТ AJAX */
	IF (!strstr($GLOBALS['_SERVER']['SCRIPT_NAME'], "ajax.php")):
	
		// Make instance:
		/** @var $SOBE tx_testtree_module1 */
		$SOBE = t3lib_div::makeInstance('tx_testtree_module1');
		$SOBE->init();

		// Include files?
		foreach ($SOBE->include_once as $INC_FILE) {
			include_once($INC_FILE);
		}

		$SOBE->main();
		$SOBE->printContent();

	ENDIF;

?>