<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Stig Nørgaard Færch (stig@altforintet.dk)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
* Class with methods called as hooks from TCE Forms
*
* @author Stig Nørgaard Færch <stig@altforintet.dk>
*/

require_once(PATH_t3lib.'class.t3lib_befunc.php');
//require_once(PATH_typo3conf.'ext/infoblock/pbild/class.tcabild.php'); //включаем класс для создания динам.tca

//данный хук показывает форму в момент редктирования (набор полей по каждому элементу отдельно)
//ПО КАЖДОМУ ЭЛЕМЕНТУ !!!!!!!!!!!!!!!!!!!!!!!!!
class user_tcamanipulate_tceforms_procTCAtitle {

	 /*
	 * @param	string		$tablename: Name of the current table
	 * @param	string		$table: The table of the current record
	 * @param	string		$id: The current record UID
	 * @return	void		Nothing returned. The fieldArray is directly changed, as it is passed by reference
	 */
	function getMainFields_preProcess($tablename, $row, $id) {
		global $TCA, $INFOBLOCK_API;
		
		
		//сохраняем на всякий случай TCA (Это нужно если у нас разные pid)
		#if ($GLOBALS['TCAtemp'][$tablename][$row['pid']] == null)
		#$GLOBALS['TCAtemp'][$tablename][$row['pid']] = $TCA[$tablename];
		
		
		
		//$msg = t3lib_div::makeInstance('t3lib_FlashMessage', 1, 
		//'Сообщение системы 1!', t3lib_FlashMessage::NOTICE);
		//t3lib_FlashMessageQueue::addMessage($msg); 
		
		
		//Присваиваем значение по умолчанию всякий
		#$TCA[$tablename] = $GLOBALS['TCAtemp'][$tablename][$row['pid']];
		
		//3.б - 4 Мы в режиме редактировать запись
		if (is_object($GLOBALS['BE_USER']) && $TCA && $row) {
		
			
			//Если у нас просят определенные колонки:
			$string_columnsOnly_2 = $GLOBALS['_GET']['columnsOnly_2'];
			if (strlen($string_columnsOnly_2) > 4){
				
				//1. Отключаем групиировк по вкладкам
				$GLOBALS['TCA'][$tablename]['ctrl']['dividers2tabs'] = false;
				
				//2. Уничтожаем не нужные колонки
				foreach ($GLOBALS['TCA'][$tablename]['columns'] as $key => $value){
				
					if (strstr($string_columnsOnly_2, "[{$key}];") == false)
					unset($GLOBALS['TCA'][$tablename]['columns'][$key]); 	//Уничтожаем колонку...
					#print $key;
					#print "<br />";
				}
				
					
				
						
				#}
			}
			
			
			#PRINT "<PRE>";
			#PRINT_R($GLOBALS['TCA']['backend_layout']);
			#EXIT();
		
		}
		
		
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tcamanipulate/class.tcamanipulate_tceforms_procTCAtitle.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tcamanipulate/class.tcamanipulate_tceforms_procTCAtitle.php']);
}

?>