<?php
if (!defined('TYPO3_MODE')) {
	die ('Access denied.');
}

###############################################################
###############################################################
###################							###################
###################	   TCA-таблиц.доска.	###################
###################	   склеиваний.			###################
###############################################################
###############################################################

$TCA['tx_board_bonding'] = array (
	'ctrl' => $TCA['tx_board_bonding']['ctrl'],
	'interface' => array (
		'showRecordFieldList' => 'title'
	),
	'feInterface' => $TCA['tx_board_bonding']['feInterface'],
	'columns' => array (
	
	
		'title' => array (		
			'exclude' => 0,		
			'label' => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.title',		
			'config' => array (
				'type' => 'input',	
				'size' => '42',	
				'max' => '72',	
				'eval' => 'required',
			)
		),
		
		
		'service_note' => array (		
			'exclude' => 0,		
			'label' => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.service_note',		
			'config' => array (
				'type' => 'text',	
				//'size' => '42',	
				//'max' => '72',	
				//'eval' => 'required',
			)
		),
		
		'ts_settings' => array (		
			'exclude' => 0,		
			'label' => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.ts_settings',		
			'config' => array (
				'type' => 'text',	
				//'size' => '42',	
				//'max' => '72',	
				//'eval' => 'required',
			)
		),
		
		
		'be_user_access' => array (		
			'exclude' => 0,		
			'label' => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.be_user_access',		
			
			'config' => array (
				
				//'readOnly' => true,
				'type' => 'select', 
				'size' => 8, 
				'minitems' => 0,
				'maxitems' => 10,
				'exclusiveKeys' => '-1', 
				
			
				'items' => array(
				
					0 => array ( 0 => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.be_user_access.allusers', 1 => -1),
					
				),
				
				'foreign_table' => 'be_users', 
				'foreign_table_where' => ' ORDER BY be_users.username ', //Доступ на администрирование
				
				
				
			)
		),
		
		
		'is_special_board_platform' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.special_board_platform',
			'config'  => array (
				'type' => 'select',
				  'items' => Array (
				  
				  
				  
				  
                    Array('LLL:EXT:boards/locallang_db.xml:tx_board_bonding.default', '0'),
					//Array('LLL:EXT:boards/locallang_db.xml:tx_board_bonding.fal_board', '2'),
					Array('LLL:EXT:boards/locallang_db.xml:tx_board_bonding.separator', '3'),
					//Array('LLL:EXT:boards/locallang_db.xml:tx_board_bonding.special_board_platform', '1'),
					
				
					
					
					
					
                ),
				'default' => '0'
			)
		),
		
				'sorting' => array (
					'label'   => 'Позиция сортировки',
					'config' => array (
						'type'		=> 'input',
						'eval' 		=> 'int',
						'size'		=> '10',
						'max'		=> '10',
					)
				),
				
		'pid' => array (
					'label'   => 'Хранилище',
					'config' => array (
						'readOnly'	=> 1,
						'type'		=> 'input',
						'eval' 		=> 'int',
						'size'		=> '5',
					)
				),
		
		'hidden' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:boards/locallang_db.xml:tx_board_bonding.hidden',
			'config'  => array (
				'type'    => 'check',
				'default' => '0'
			)
		),
		
		
		////////**************для прогресс бара******************//////////
		'ext_infoblock_percentages' => $tempElem['sliderconf'], //slider
		'ext_infoblock_todo' => $tempElem['textconf'], //todo
		////////**************для прогресс бара******************//////////
		
	),
	'types' => array (
		   '0' => array('showitem' => '--div--;LLL:EXT:boards/locallang_db.xml:tx_board_bonding.tab_1,
									title;;;;1-1-1, service_note;;;;1-1-1, is_special_board_platform;;;;1-1-1, sorting;;;;1-1-1, pid;;;;1-1-1,
									--div--;LLL:EXT:boards/locallang_db.xml:tx_board_bonding.tab_2,
									ts_settings,
									hidden,
									' .$tempElem['addstructure'] /** прогресс бар **/ ),
			
			//Специальная доска платформы
			'1' => array('showitem' => '--div--;LLL:EXT:boards/locallang_db.xml:tx_board_bonding.tab_1,
										title;;;;1-1-1, service_note;;;;1-1-1, sorting;;;;1-1-1,
										pid;;;;1-1-1'),
										
			//Разделитель
			'3' => array('showitem' => '--div--;LLL:EXT:boards/locallang_db.xml:tx_board_bonding.tab_1,
										title;;;;1-1-1, service_note;;;;1-1-1, is_special_board_platform;;;;1-1-1, sorting;;;;1-1-1, 
										--div--;LLL:EXT:boards/locallang_db.xml:tx_board_bonding.tab_3,
										hidden,
										pid;;;;1-1-1'	),
								
									
	),
);


?>